#ifndef _INCLUDED_APPLICATION_H_
#define _INCLUDED_APPLICATION_H_

#include "configure.h"

#if !defined(USE_3D_LAYER) || USE_3D_LAYER == 0
# define APPLICATION_NAME "KABURAGI"
#else
# define APPLICATION_NAME "MIKADO"
#endif

#define MAJOR_VERSION 1

#if MAJOR_VERSION == 1
# define MINOR_VERSION 3
# define RELEASE_VERSION 2
# define BUILD_VERSION 1
#elif MAJOR_VERSION == 2
# define MINOR_VERSION 0
# define RELEASE_VERSION 1
# define BUILD_VERSION 1
#endif

#define FILE_VERSION 4

#include "draw_window.h"
// `̈̍ő吔
#define MAX_DRAW_WINDOW 128
// ^b`Cxgo̍ő吔
#define MAX_TOUCH 10
// 3Df쎞̃XN[o[̃}[W
#define SCROLLED_WINDOW_MARGIN 32

#include "lcms/lcms2.h"
#include "labels.h"
#include "tool_box.h"
#include "layer_window.h"
#include "navigation.h"
#include "preview_window.h"
#include "reference_window.h"
#include "brush_core.h"
#include "common_tools.h"
#include "vector_brush_core.h"
#include "vector_brushes.h"
#include "color.h"
#include "pattern.h"
#include "texture.h"
#include "smoother.h"
#include "preference.h"
#include "display_filter.h"
#include "fractal_label.h"

#if defined(USE_3D_LAYER) && USE_3D_LAYER != 0
# include "MikuMikuGtk+/mikumikugtk.h"
# include "MikuMikuGtk+/ui_label.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

// t@C̃t@CpX
#define INITIALIZE_FILE_NAME "application.ini"
// pbgt@C̃pX
#define PALLETE_FILE_NAME "pallete.kpl"
// ftHg̉𑜓x
#define DEFALUT_RESOLUTION 96

typedef enum _eUTILITY_PLACE
{
	UTILITY_PLACE_WINDOW,
	UTILITY_PLACE_LEFT,
	UTILITY_PLACE_RIGHT
} eUTILITY_PLACE;

typedef enum _eTOOL_WINDOW_FLAGS
{
	TOOL_USING_BRUSH = 0x01,
	TOOL_DOCKED = 0x02,
	TOOL_PLACE_RIGHT = 0x04,
	TOOL_SHOW_COLOR_CIRCLE = 0x08,
	TOOL_SHOW_COLOR_PALLETE = 0x10
} eTOOL_WINDOW_FLAGS;

/*************************************************
* eAPPLICATION_FLAGS񋓑                       *
* AvP[Ṽt@C쒆ŗtO *
*************************************************/
typedef enum _eAPPLICATION_FLAGS
{
	APPLICATION_IN_OPEN_OPERATION = 0x01,			// t@CI[v
	APPLICATION_IN_MAKE_NEW_DRAW_AREA = 0x02,		// `̈̐VK쐬
	APPLICATION_IN_REVERSE_OPERATION = 0x04,		// E]
	APPLICATION_IN_EDIT_SELECTION = 0x08,			// I͈͕ҏW؂ւ
	APPLICATION_INITIALIZED = 0x10,					// ς
	APPLICATION_IN_DELETE_EVENT = 0x20,				// 폜Cxg
	APPLICATION_FULL_SCREEN = 0x40,					// tXN[[h
	APPLICATION_WINDOW_MAXIMIZE = 0x80,				// EBhE̍ő剻
	APPLICATION_DISPLAY_GRAY_SCALE = 0x100,			// O[XP[ł̕\
	APPLICATION_DISPLAY_SOFT_PROOF = 0x200,			// ICCvt@CŃ\tgv[t\
	APPLICATION_REMOVE_ACCELARATOR = 0x400,			// V[gJbgL[𖳌
	APPLICATION_DRAW_WITH_TOUCH = 0x800,			// ^b`Cxgŕ`悷
	APPLICATION_SET_BACK_GROUND_COLOR = 0x1000,		// LoX̔wiݒ肷
	APPLICATION_SHOW_PREVIEW_ON_TASK_BAR = 0x2000,	// vr[EBhE^XNo[ɕ\
	APPLICATION_IN_SWITCH_DRAW_WINDOW = 0x4000		// `̈̐ؑ֒
} eAPPLICATION_FLAGS;

#define DND_THRESHOLD 20

#define BRUSH_TABLE_WIDTH (4)
#define BRUSH_TABLE_HEIGHT (16)

#define MAX_BRUSH_SIZE 500
#define MAX_BRUSH_STRIDE ((MAX_BRUSH_SIZE) * 4)

#define VECTOR_BRUSH_TABLE_WIDTH (4)
#define VECTOR_BRUSH_TABLE_HEIGHT (8)

#define COMMON_TOOL_TABLE_WIDTH 5
#define COMMON_TOOL_TABLE_HEIGHT 2

#define THUMBNAIL_SIZE 128

#define PALLETE_WIDTH 16
#define PALLETE_HEIGHT 16

typedef enum _eINPUT_DEVICE
{
	INPUT_PEN,
	INPUT_ERASER
} eINPUT_DEVICE;

/*************************
* TOOL_WINDOW\      *
* c[{bNX̃f[^ *
*************************/
typedef struct _TOOL_WINDOW
{
	// EBhEAuVe[uAuVe[ũXN[
	GtkWidget *window, *common_tool_table, *brush_table, *brush_scroll;
	// j[EBWFbg
	GtkWidget *menu_item;
	// uVe[uƏڍאݒ؂y[
	GtkWidget *pane;
	// EBWFbg̔zu
	int place;
	// EBhËʒuATCY
	int window_x, window_y, window_width, window_height;
	// uVe[uƏڍאݒ؂y[̈ʒu
	gint pane_position;
	// uV{^ɎgptHg
	char* font_file;
	// FIp̃f[^
	COLOR_CHOOSER *color_chooser;
	// uṼRAe[u
	BRUSH_CORE brushes[BRUSH_TABLE_HEIGHT][BRUSH_TABLE_WIDTH];
#if GTK_MAJOR_VERSION >= 3
	// ^b`Cxgp̃f[^
	BRUSH_CORE touch[MAX_TOUCH];
	// wp
	GdkEventSequence *fingers[MAX_TOUCH];
	// ݂̃^b`Cxg̎w̐
	int num_touch;
#endif
	// ݎgpĂuVւ̃|C^
	BRUSH_CORE *active_brush[2];
	// uV摜̃sNZf[^
	uint8 *brush_pattern_buff, *temp_pattern_buff;
	// Rs[uVւ̃|C^
	void *copy_brush;
	// uVt@C̕R[h
	char *brush_code;
	// ʃc[̃uVe[u
	COMMON_TOOL_CORE common_tools[COMMON_TOOL_TABLE_HEIGHT][COMMON_TOOL_TABLE_WIDTH];
	// ݎgpĂ鋤ʃc[ւ̃|C^
	COMMON_TOOL_CORE* active_common_tool;
	// ʃc[t@C̕R[h
	char *common_tool_code;
	// xNguṼRAe[u
	VECTOR_BRUSH_CORE vector_brushes[VECTOR_BRUSH_TABLE_HEIGHT][VECTOR_BRUSH_TABLE_WIDTH];
	// ݎgpĂxNguVւ̃|C^
	VECTOR_BRUSH_CORE *active_vector_brush[2];
	// xNguVt@C̕R[h
	char *vector_brush_code;
	// ʏ탌C[ControlL[ĂƂ̓X|Cgc[ɕ΍邽
		// X|Cgc[̃f[^ێĂ
	COMMON_TOOL_CORE color_picker_core;
	COLOR_PICKER color_picker;
	// xNgC[ControlAShiftL[ĂƂɂ͐_c[ɕω邽
		// _c[̃f[^ێĂ
	VECTOR_BRUSH_CORE vector_control_core;
	CONTROL_POINT_TOOL vector_control;
	// uVUIEBWFbg
	GtkWidget *ui, *detail_ui, *detail_ui_scroll;
	// u␳̏
	SMOOTHER smoother;
	// vOCuV
	GModule *plug_in_brush;
	// ^b`Cxgp̎u␳
#if GTK_MAJOR_VERSION >= 3
	SMOOTHER touch_smoother[MAX_TOUCH];
#endif
	// pbg̏
	uint8 pallete[(PALLETE_WIDTH*PALLETE_HEIGHT)][3];
	uint8 pallete_use[((PALLETE_WIDTH*PALLETE_HEIGHT)+7)/8];
	// c[{bNXŜňtO
	unsigned int flags;
} TOOL_WINDOW;

/*************************************************************************
* APPLICATION_MENUS\                                                *
* AvP[Vŕ`̗̈LŗLAω郁j[L *
*************************************************************************/
typedef struct _APPLICATION_MENUS
{	// `̈悪Ƃɖ
	GtkWidget *disable_if_no_open[80];
	// I͈͂Ƃɖ
	GtkWidget *disable_if_no_select[32];
	// C[ꖇȂƂɖ
	GtkWidget *disable_if_single_layer[8];
	// ʏ̃C[̂Ƃɖ
	GtkWidget *disable_if_normal_layer[8];
	uint8 num_disable_if_no_open;
	uint8 menu_start_disable_if_no_open;
	uint8 num_disable_if_no_select;
	uint8 menu_start_disable_if_no_select;
	uint8 num_disable_if_single_layer;
	uint8 menu_start_disable_if_single_layer;
	uint8 num_disable_if_normal_layer;
	uint8 menu_start_disable_if_normal_layer;
	// ̃C[ƌj[
	GtkWidget *merge_down_menu;
	// wiF؂ւj[
	GtkWidget *change_back_ground_menu;
	// \tB^[؂ւj[
	GtkWidget *display_filter_menus[NUM_DISPLAY_FUNC_TYPE];
} APPLICATION_MENUS;

/***********************
* MENU_DATA\      *
* j[ňf[^ *
***********************/
typedef struct _MENU_DATA
{
	struct
	{
		int32 width, height;
		int16 resolution;
		uint8 second_bg_color[3];
	} make_new;

	GtkWidget *reverse_horizontally;
	GtkWidget *edit_selection;
} MENU_DATA;

/*****************************************
* SCRIPTS\                          *
* XNvgfBNg̃XNvg *
*****************************************/
typedef struct _SCRIPTS
{
	gchar **file_paths;
	gchar **file_names;
	int num_script;
} SCRIPTS;

/*************************************
* APPLICATION\                  *
* AvP[VŜ̃f[^Ǘ *
*************************************/
typedef struct _APPLICATION
{
	// EBhEAj[A^upbLO{bNXA^u
	GtkWidget *window, *vbox, *note_book;
	// j[o[
	GtkWidget *menu_bar;
	// Xe[^Xo[
	GtkWidget *status_bar;
	// ۑAtB^[̐i󋵂\vOXo[
	GtkWidget *progress;
	// VOEBhEpɃc[鍶Ẽy[
	GtkWidget *left_pane, *right_pane;
	// irQ[VƃC[r[hbLO邽߂̃{bNX
	GtkWidget *navi_layer_pane;
	// EBhËʒuATCY
	int window_x, window_y, window_width, window_height;
	// Ey[̈ʒu
	gint left_pane_position, right_pane_position;
	// V[gJbgL[
	GtkAccelGroup *hot_key;
	// ̓foCX
	eINPUT_DEVICE input;
	// `̈
	DRAW_WINDOW *draw_window[MAX_DRAW_WINDOW];
	// c[EBhE
	TOOL_WINDOW tool_window;
	// C[EBhE
	LAYER_WINDOW layer_window;
	// irQ[VEBhE
	NAVIGATION_WINDOW navigation_window;
	// vr[EBhE
	PREVIEW_WINDOW preview_window;
	// Qlp摜\EBhE
	REFERENCE_WINDOW reference_window;
	// ݒ
	PREFERENCE preference;
	// `̈̏Ԃɍ킹ėLA؂ւ郁j[
	APPLICATION_MENUS menus;
	// \ɓKptB^[̃f[^
	DISPLAY_FILTER display_filter;
	// `̈̐
	int window_num;
	// ݃ANeBuȕ`̈
	int active_window;

	// gp\ȃtHgXg
	PangoFontFamily** font_list;
	// gp\ȃtHg̐
	int num_font;

	// uVeNX`p
	TEXTURES textures;
	// gpeNX`̃x
	GtkWidget *texture_label;

	// UIɕ\镶
	APPLICATION_LABELS *labels;
	FRACTAL_LABEL *fractal_labels;

	// VXẽR[h
	char *system_code;
	// st@C̃pX
	char *current_path;
	// t@C̃pX
	char *language_file_path;
	// uVt@C̃pX
	char *brush_file_path;
	// xNguVt@C̃pX
	char *vector_brush_file_path;
	// ʃc[t@C̃pX
	char *common_tool_file_path;
	// obNAbv쐬fBNg̃pX
	char *backup_directory_path;
	// p^[t@ĈfBNgւ̃pX
	char *pattern_path;
	// X^vt@ĈfBNgւ̃pX
	char *stamp_path;
	// eNX`摜̂fBNgւ̃pX
	char *texture_path;
	// XNvgt@ĈfBNgւ̃pX
	char *script_path;

	// XNvg̃t@C
	SCRIPTS scripts;

	// VK쐬Ȃǂ̃j[ňf[^
	MENU_DATA menu_data;

	// E]̃{^ƃx
	GtkWidget *reverse_button, *reverse_label;

	// I͈͕ҏW̃{^
	GtkWidget *edit_selection;

	// t@CI[v̑쒆ɗtO
	unsigned int flags;

	// p̃f[^
	GtkPrintSettings* print_settings;
	// T[tF[X
	cairo_surface_t* print_surface;
	// sNZf[^
	uint8* print_pixels;

	// \̃c[
	uint16 current_tool;

	// ICCvt@Cւ̃pX
	char *input_icc_path;
	char *output_icc_path;

	// ICCvt@C̓e
	cmsHPROFILE input_icc;
	cmsHPROFILE output_icc;
	// ICCvt@CɂFϊp
	cmsHTRANSFORM icc_transform;

	// p^[hׂp
	PATTERNS patterns;
	// X^vp
	PATTERNS stamps;
	uint8 *stamp_buff;
	uint8 *stamp_shape;
	uint8 *stamp_alpha;
	size_t stamp_buff_size;

#ifndef _WIN32
	// Ubuntuł̓c[̐؂ւȂȂ̂
		// foCX̐ݒLKv?
	int num_device;
	GdkInputSource *input_sources;
	gboolean *set_input_modes;
#endif

#if defined(USE_3D_LAYER) && USE_3D_LAYER != 0
	// 3DfOpf[^
	void *modeling;
#endif
} APPLICATION;

// ֐̃vg^Cv錾
/*********************************************************************
* InitializeApplication֐                                          *
* AvP[V̏                                           *
*                                                                *
* app				: AvP[VŜǗ\̂̃AhX *
* init_file_name	: t@C̖O                           *
*********************************************************************/
EXTERN void InitializeApplication(APPLICATION* app, char* init_file_name);

/*********************************************************
* GetActiveDrawWindow֐                                *
* ANeBuȕ`̈擾                         *
*                                                    *
* app		: AvP[VǗ\̂̃AhX *
* Ԃl                                                 *
*	ANeBuȕ`̈                                 *
*********************************************************/
EXTERN DRAW_WINDOW* GetActiveDrawWindow(APPLICATION* app);

/*****************************************************
* RecoverBackUp֐                                  *
* obNAbvt@Cꍇɕ         *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void RecoverBackUp(APPLICATION* app);

EXTERN GtkWidget *CreateToolBoxWindow(struct _APPLICATION* app, GtkWidget *parent);

EXTERN void CreateBrushTable(
	APPLICATION* app,
	TOOL_WINDOW* window,
	BRUSH_CORE brush_data[BRUSH_TABLE_HEIGHT][BRUSH_TABLE_WIDTH]
);

EXTERN void CreateVectorBrushTable(
	APPLICATION* app,
	TOOL_WINDOW* window,
	VECTOR_BRUSH_CORE brush_data[VECTOR_BRUSH_TABLE_HEIGHT][VECTOR_BRUSH_TABLE_WIDTH]
);

#if defined(USE_3D_LAYER) && USE_3D_LAYER != 0
EXTERN void CreateChange3DLayerUI(
	APPLICATION* app,
	TOOL_WINDOW* window
);
#endif

/*********************************************************
* WriteCommonToolData֐                                *
* ʃc[̃f[^o                           *
*                                                    *
* window	: c[{bNX                             *
* file_path	: ot@C̃pX                     *
* app		: AvP[VǗ\̂̃AhX *
* Ԃl                                                 *
*	I:0 s:̒l                               *
*********************************************************/
EXTERN int WriteCommonToolData(
	TOOL_WINDOW* window,
	const char* file_path,
	APPLICATION* app
);

/*********************************************************
* WriteVectorBrushData֐                               *
* xNgC[p̃uVe[ũf[^o   *
*                                                    *
* window	: c[{bNXEBhE                   *
* file_path	: ot@C̃pX                     *
* app		: AvP[VǗ\̂̃AhX *
* Ԃl                                                 *
*	I:0	s:̒l                              *
*********************************************************/
EXTERN int WriteVectorBrushData(
	struct _TOOL_WINDOW* window,
	const char* file_path,
	struct _APPLICATION* app
);

/*******************************************************
* OnQuitApplication֐                                *
* AvP[VIOɌĂяoR[obN֐ *
*                                                  *
* app	: AvP[VǗ\̂̃AhX   *
* Ԃl                                               *
*	I~:TRUE	Is:FALSE                     *
*******************************************************/
EXTERN gboolean OnQuitApplication(APPLICATION* app);

#ifndef INCLUDE_WIN_DEFAULT_API
/*********************************************************
* OpenFile֐                                           *
* 󂯂ƂpX̃t@CJ                         *
*                                                    *
* file_path	: t@CpX                               *
* app		: AvP[VǗ\̂̃AhX *
*********************************************************/
EXTERN void OpenFile(char *file_path, APPLICATION* app);
#endif

/*********************************************************
* ExecuteOpenFile֐                                    *
* t@CJ                                         *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void ExecuteOpenFile(APPLICATION* app);

/*********************************************************
* ExecuteOpenFileAsLayer֐                             *
* C[Ƃăt@CJ                           *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void ExecuteOpenFileAsLayer(APPLICATION* app);

/*********************************************************
* ExecuteSave֐                                        *
* ㏑ۑ                                             *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void ExecuteSave(APPLICATION* app);

/*********************************************************
* ExecuteSaveAs֐                                      *
* Otĕۑ                                       *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void ExecuteSaveAs(APPLICATION* app);

/*********************************************************
* ExecuteClose֐                                       *
* ANeBuȕ`̈                           *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void ExecuteClose(APPLICATION* app);

/*****************************************************
* ExecuteMakeColorLayer֐                          *
* ʏ탌C[쐬s                             *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteMakeColorLayer(APPLICATION *app);

/*****************************************************
* ExecuteMakeVectorLayer֐                         *
* VKxNgC[쐬s                     *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteMakeVectorLayer(APPLICATION *app);

/*****************************************************
* ExecuteMakeLayerSet֐                            *
* VKC[Zbg쐬s                       *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteMakeLayerSet(APPLICATION *app);

#if defined(USE_3D_LAYER) && USE_3D_LAYER != 0
/*****************************************************
* ExecuteMake3DLayer֐                             *
* 3DfOC[쐬s                     *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteMake3DLayer(APPLICATION* app);
#endif

/*********************************************************
* DeleteActiveLayer֐                                  *
* ݂̃ANeBuC[폜                     *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void DeleteActiveLayer(APPLICATION* app);

/*****************************************************
* ExecuteUpLayer֐                                 *
* C[̏1ɕύX                    *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteUpLayer(APPLICATION* app);

/*****************************************************
* ExecuteDownLayer֐                               *
* C[̏1ɕύX                    *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteDownLayer(APPLICATION* app);

/*********************************************************
* FillForeGroundColor֐                                *
* `FŃANeBuC[hԂ                 *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void FillForeGroundColor(APPLICATION* app);

/*********************************************************
* FillPattern֐                                        *
* ANeBuȃp^[ŃANeBuȃC[hׂ   *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void FillPattern(APPLICATION* app);

/*********************************************************
* FlipImageHorizontally֐                              *
* `̈E]                                 *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void FlipImageHorizontally(APPLICATION* app);

/*********************************************************
* FlipImageVertically֐                                *
* `̈㉺]                                 *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void FlipImageVertically(APPLICATION* app);

/*****************************************************
* SwitchSecondBackColor֐                          *
* wiF2߂̂̂Ɠւ                    *
*                                                *
* menu	: j[EBWFbg                       *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void SwitchSecondBackColor(GtkWidget* menu, APPLICATION* app);

/*****************************************************
* Change2ndBackColor֐                             *
* 2߂̔wiFύX                            *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void Change2ndBackColor(APPLICATION* app);

/*********************************************************
* MergeDownActiveLayer֐                               *
* ANeBuȃC[̃C[ƌ           *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void MergeDownActiveLayer(APPLICATION* app);

/*********************************************************
* FlattenImage֐                                       *
* 摜̓s                                       *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void FlattenImage(APPLICATION* app);

/*********************************************************
* ActiveLayerAlpha2SelectionArea֐                     *
* ANeBuC[̕sI͈͂ɂ         *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void ActiveLayerAlpha2SelectionArea(APPLICATION* app);

/*********************************************************
* ActiveLayerAlphaAddSelectionArea֐                   *
* ANeBuC[̕sI͈͂ɉ       *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void ActiveLayerAlphaAddSelectionArea(APPLICATION* app);

/*********************************************************
* ExecuteCopyLayer֐                                   *
* C[̕s                               *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void ExecuteCopyLayer(APPLICATION* app);

/*********************************************************
* ExecuteVisible2Layer֐                               *
* C[ɂ                                 *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void ExecuteVisible2Layer(APPLICATION* app);

/*********************************************************
* RasterizeActiveLayer֐                               *
* ANeBuC[X^CY                   *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void RasterizeActiveLayer(APPLICATION* app);

/*********************************************************
* ExecuteSelectAll֐                                   *
* SđIs                                         *
*                                                    *
* app	: AvP[VŜǗ\̂̃AhX *
*********************************************************/
EXTERN void ExecuteSelectAll(APPLICATION* app);

/*****************************************************
* ExecuteZoomIn֐                                  *
* gs                                         *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteZoomIn(APPLICATION *app);

/*****************************************************
* ExecuteZoomReset֐                               *
* {\s                                     *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteZoomReset(APPLICATION* app);

/*****************************************************
* ExecuteRotateClockwise֐                         *
* \vɉ]                               *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteRotateClockwise(APPLICATION* app);

/*****************************************************
* ExecuteRotateCounterClockwise֐                  *
* \𔽎vɉ]                             *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteRotateCounterClockwise(APPLICATION* app);

/*****************************************************
* ExecuteRotateReset֐                             *
* ]pxZbg                             *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteRotateReset(APPLICATION* app);

/*****************************************************
* ExecuteChangeResolution֐                        *
* LoX̉𑜓xύXs                       *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteChangeResolution(APPLICATION* app);

/*****************************************************
* ExecuteZoomOut֐                                 *
* ks                                         *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteZoomOut(APPLICATION *app);

/*****************************************************
* ExecuteChangeCanvasSize֐                        *
* LoX̃TCYύXs                       *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteChangeCanvasSize(APPLICATION* app);

/*****************************************************
* ExecuteChangeCanvasIccProfile֐                  *
*                                                *
* menu	: j[EBWFbg                       *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteChangeCanvasIccProfile(GtkWidget* menu, APPLICATION* app);

EXTERN void ExecuteUndo(struct _APPLICATION* app);
EXTERN void ExecuteRedo(struct _APPLICATION* app);

/*********************************************************
* FillLayerPattern֐                                   *
* C[p^[œhׂ                           *
*                                                    *
* target	: hׂsC[                     *
* patterns	: p^[Ǘ\̂̃AhX         *
* app		: AvP[VǗ\̂̃AhX *
* color		: p^[O[XP[̂ƂɎgF     *
*********************************************************/
EXTERN void FillLayerPattern(
	struct _LAYER* target,
	struct _PATTERNS* patterns,
	struct _APPLICATION* app,
	uint8 color[3]
);

EXTERN void AddLayerNameChangeHistory(
	APPLICATION* app,
	const gchar* before_name,
	const gchar* after_name
);

/*********************************************************************
* InitializeNavigation֐                                           *
* irQ[VEBhE                                   *
*                                                                *
* navigation	: irQ[VEBhEǗ\̂̃AhX *
* app			: AvP[VǗ\̂̃AhX         *
* box			: hbLOꍇ̓{bNXEBWFbgw     *
*********************************************************************/
EXTERN void InitializeNavigation(
	NAVIGATION_WINDOW* navigation,
	APPLICATION *app,
	GtkWidget* box
);

EXTERN void InitializePreviewWindow(PREVIEW_WINDOW* preview, APPLICATION* app);

EXTERN void UnSetSelectionArea(APPLICATION* app);

EXTERN void InvertSelectionArea(APPLICATION* app);

/*****************************************************
* ReductSelectionArea֐                            *
* I͈͂k                                 *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ReductSelectionArea(APPLICATION* app);

/*********************************************************
* ChangeEditSelectionMode֐                            *
* I͈͕ҏW[h؂ւ                         *
*                                                    *
* menu_item	: j[ACeEBWFbg               *
* app		: AvP[VǗ\̂̃AhX *
*********************************************************/
EXTERN void ChangeEditSelectionMode(GtkWidget* menu_item, APPLICATION* app);

/*************************************************************
* Move2ActiveLayer                                           *
* C[r[ANeBuȃC[ɃXN[           *
* widget		: ANeBuC[̃EBWFbg           *
* allocation	: EBWFbgɊ蓖ĂꂽTCY         *
* app			: AvP[VǗ\̂̃AhX *
*************************************************************/
EXTERN void Move2ActiveLayer(GtkWidget* widget, GdkRectangle * allocation, APPLICATION* app);

EXTERN void TextLayerButtonPressCallBack(
	DRAW_WINDOW* window,
	gdouble x,
	gdouble y,
	GdkEventButton* event
);

EXTERN void TextLayerMotionCallBack(
	DRAW_WINDOW* window,
	gdouble x,
	gdouble y,
	GdkModifierType state
);

EXTERN GtkWidget* CreateTextLayerDetailUI(APPLICATION* app, struct _LAYER* target, TEXT_LAYER* layer);

/*********************************************************
* ExecuteChangeToolWindowPlace֐                       *
* c[{bNẌʒuύX                         *
*                                                    *
* menu_item	: j[ACeEBWFbg               *
* app		: AvP[VǗ\̂̃AhX *
*********************************************************/
EXTERN void ExecuteChangeToolWindowPlace(GtkWidget* menu_item, APPLICATION* app);

/*********************************************************
* ExecuteChangeNavigationLayerWindowPlace֐            *
* irQ[VƃC[r[̈ʒuύX         *
*                                                    *
* menu_item	: ʒuύXj[ACeEBWFbg       *
* app		: AvP[VǗ\̂̃AhX *
*********************************************************/
EXTERN void ExecuteChangeNavigationLayerWindowPlace(GtkWidget* menu_item, APPLICATION* app);

/*************************************************************
* TextFieldFocusIn֐                                       *
* eLXgC[̕ҏWEBWFbgtH[JXꂽ   *
*   ĂяoR[obN֐                             *
*                                                        *
* text_field	: eLXgC[̕ҏWEBWFbg         *
* focus			: Cxg̏                             *
* app			: AvP[VǗ\̂̃AhX *
* Ԃl                                                     *
*	FALSE                                                *
*************************************************************/
EXTERN gboolean TextFieldFocusIn(GtkWidget* text_field, GdkEventFocus* focus, APPLICATION* app);

/*******************************************************************
* TextFieldFocusOut֐                                            *
* eLXgC[̕ҏWEBWFbgtH[JXړ *
*   ĂяoR[obN֐                                   *
*                                                              *
* text_field	: eLXgC[̕ҏWEBWFbg               *
* focus			: Cxg̏                                   *
* app			: AvP[VǗ\̂̃AhX       *
* Ԃl                                                           *
*	FALSE                                                      *
*******************************************************************/
EXTERN gboolean TextFieldFocusOut(GtkWidget* text_field, GdkEventFocus* focus, APPLICATION* app);

/*************************************************************
* OnDestroyTextField֐                                     *
* eLXgC[̕ҏWEBWFbg폜鎞         *
*   ĂяoR[obN֐                             *
*                                                        *
* text_field	: eLXgC[̕ҏWEBWFbg         *
* app			: AvP[VǗ\̂̃AhX *
*************************************************************/
EXTERN void OnDestroyTextField(GtkWidget* text_field, APPLICATION* app);

/*****************************************************
* ExtendSelectionArea֐                            *
* I͈͂g傷                                 *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExtendSelectionArea(APPLICATION* app);

/*****************************************************
* ExecuteSetPreference֐                           *
* ݒύX                                 *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void ExecuteSetPreference(APPLICATION* app);

/*****************************************************
* DisplayVersion֐                                 *
* o[W\                           *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void DisplayVersion(APPLICATION* app);

/*************************************************
* ChangeNavigationRotate֐                     *
* irQ[V̉]pxύXɌĂяo֐   *
*                                            *
* navigation	: irQ[VEBhȄ *
* draw_window	: \`̈               *
*************************************************/
EXTERN void ChangeNavigationRotate(NAVIGATION_WINDOW* navigation, DRAW_WINDOW* window);

/*************************************************
* ChangeNavigationDrawWindow֐                 *
* irQ[Vŕ\`̈ύX     *
*                                            *
* navigation	: irQ[VEBhȄ *
* draw_window	: \`̈               *
*************************************************/
EXTERN void ChangeNavigationDrawWindow(NAVIGATION_WINDOW* navigation, DRAW_WINDOW* window);

/*****************************************************
* NoDisplayFilter֐                                *
* \̃tB^[It                           *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void NoDisplayFilter(APPLICATION* app);

/*****************************************************
* GrayScaleDisplayFilter֐                         *
* \̃tB^[O[XP[ϊ̂̂     *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void GrayScaleDisplayFilter(APPLICATION* app);

/******************************************************************
* GrayScaleDisplayFilterYIQ֐                                   *
* \̃tB^[O[XP[ϊ(YIQJ[f)̂̂ *
*                                                             *
* app	: AvP[VǗ\̂̃AhX              *
******************************************************************/
EXTERN void GrayScaleDisplayFilterYIQ(APPLICATION* app);

/*****************************************************
* IccProfileDisplayFilter֐                        *
* \̃tB^[ICCvt@CKp̂̂    *
*                                                *
* menu	: j[EBWFbg                       *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
EXTERN void IccProfileDisplayFilter(GtkWidget* menu, APPLICATION* app);

/*********************************************************
* CreateTextureChooser֐                               *
* eNX`IEBWFbg쐬             *
*                                                    *
* texture	: eNX`Ǘ\̂̃AhX       *
* app		: AvP[VǗ\̂̃AhX *
* Ԃl                                                 *
*	eNX`IEBhEEBWFbg           *
*********************************************************/
EXTERN GtkWidget* CreateTextureChooser(TEXTURES* textures, struct _APPLICATION* app);

/***************************************************************
* InitializeScripts֐                                        *
* XNvgfBNgɂt@Cꗗ쐬               *
*                                                          *
* scripts		: XNvgt@CǗ\̂̃AhX *
* scripts_path	: XNvgfBNg̃pX                 *
***************************************************************/
EXTERN void InitializeScripts(SCRIPTS* scripts, const char* scripts_path);

/*********************************************************
* ExecuteScript֐                                      *
* j[XNvgIꂽ̃R[obN֐ *
*                                                    *
* menu_item	: j[ACeEBWFbg               *
* app		: AvP[VǗ\̂̃AhX *
*********************************************************/
EXTERN void ExecuteScript(GtkWidget* menu_item, APPLICATION* app);

/*********************************************************
* Change2LoupeMode֐                                   *
* [y[hֈڍs                                 *
*                                                    *
* app		: AvP[VǗ\̂̃AhX *
*********************************************************/
EXTERN void Change2LoupeMode(APPLICATION* app);

/*********************************************************
* ReturnFromLoupeMode֐                                *
* [y[h߂                                   *
*                                                    *
* app		: AvP[VǗ\̂̃AhX *
*********************************************************/
EXTERN void ReturnFromLoupeMode(APPLICATION* app);

/*********************************************************
* LayerViewSetDrawWindow֐                             *
* C[r[ɃLoX̑SẴC[Zbg *
*                                                    *
* layer_window	: C[r[EBhE         *
* draw_window	: `̈                               *
*********************************************************/
EXTERN void LayerViewSetDrawWindow(LAYER_WINDOW* layer_window, DRAW_WINDOW* draw_window);

/*****************************************************************
* LoupeButtonToggled֐                                         *
* [y[h؂ւ{^NbNꂽ̃R[obN֐ *
*                                                            *
* button	: {^EBWFbg                                 *
* app		: AvP[VǗ\̂̃AhX         *
*****************************************************************/
EXTERN void LoupeButtonToggled(GtkWidget* button, APPLICATION* app);

/**************************************************************
* MemoryFree֐                                              *
* KABURAGI / MIKADOŊmۂꂽJ(vOCp) *
*                                                         *
* memory	: J郁̃|C^                        *
**************************************************************/
EXTERN void MemoryFree(void* memory);

#if defined(USE_3D_LAYER) && USE_3D_LAYER != 0
/*****************************************************************
* Load3dModelingLabels֐                                       *
* 3Df쎞̃xf[^ǂݍ                         *
* app				: AvP[VǗ\̂̃AhX *
* lang_file_path	: x̃eLXgf[^t@C̃pX       *
*****************************************************************/
EXTERN void Load3dModelingLabels(APPLICATION* app, const char* lang_file_path);
#endif

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INCLUDED_APPLICATION_H_
