#ifndef _INCLUDED_AUDIO_PLAYER_H_
#define _INCLUDED_AUDIO_PLAYER_H_

#include <stdio.h>
#include "libavcodec/avcodec.h"
#include "libavformat/avformat.h"
#include "libswresample/swresample.h"
#include <AL/al.h>
#include <AL/alc.h>
#include "file_list_view.h"
#include "types.h"

#ifdef __cplusplus
extern "C" {
#endif

// 萔
// f[^ǂݍރobt@̃oCg
#define AUDIO_PLAYER_BUFFER_SIZE 20480
// Đobt@̐
#define AUDIO_PLAYER_PLAY_BUFFER_NUM 32
// Đobt@̃TCY
#define AUDIO_PLAYER_PLAY_BUFFER_SIZE 8192

// e퓮߂tO
typedef enum _eAUDIO_PLAYER_FLAGS
{
	AUDIO_PLAYER_OPENED = 0x01,
	AUDIO_PLAYER_FILE_END = 0x02
} eAUDIO_PLAYER_FLAGS;

/*
* AUDIO_PLAYER\
* Đp̃f[^
*/
typedef struct _AUDIO_PLAYER
{
	// fR[h̃ReLXg
	AVCodecContext *context;
	// f[^̃tH[}bg
	AVFormatContext *format;
	// f[^͗p̃ReLXg
	AVIOContext *read_context;
	// f[^̃pPbg
	AVPacket packet;
	// fR[ht[
	AVFrame *frame;
	// XeIf[^ւ̕ϊpReLXg
	SwrContext *swr_context;
	// f[^ւ̃|C^
	void *stream;
	// f[^ǂݍݗp̊֐|C^
	size_t (*read_func)(void*, size_t, size_t, void*);
	// f[^V[Np̊֐|C^
	int (*seek_func)(void*, long, int);
	// f[^ʒu擾p̊֐|C^
	long (*tell_func)(void*);
	// f[^jɌĂяo֐̃|C^
	void (*on_destroy_func)(void*);
	// f[^ǂݍݐ̃obt@
	uint8 buffer[AUDIO_PLAYER_BUFFER_SIZE + FF_INPUT_BUFFER_PADDING_SIZE];
	// OpenAL(Đsp)̃foCXf[^
	ALCdevice *alc_device;
	// OpenAL(Đsp)̃ReLXg
	ALCcontext *alc_context;
	// Đf[^̃\[X
	ALuint source;
	// Đf[^̃obt@
	ALuint play_buffer;
	// Đf[^̃tH[}bg
	ALenum play_format;
	// fR[hf[^obt@
	uint8 *decode_buffer;
	// Đ̏
	ALint state;
	// f[^̃obt@̐
	int num_buffer;
	// f[^̃TvO[g
	int sample_rate;
	// Tvf[^̃oCg
	int sample_size;
	// f[^ Xg[̃CfbNX
	int stream_index;
	// f[^̃`l
	uint8 channels;
	// tO
	unsigned int flags;
} AUDIO_PLAYER;

// ֐̃vg^Cv錾

/*
* AudioPlayerNew֐
* Đp̃mۋyя
* 
* stream			: f[^ւ̃|C^
* read_func			: f[^ǂݍݗp̊֐|C^
* seek_func			: f[^V[Np̊֐|C^
* tell_func			: f[^ʒu擾p̊֐|C^
* meta_data			: ^f[^̕ۑ
* on_destroy_func	: f[^jɌĂяo֐|C^
* Ԃl
*	ꂽ\̂̃AhX
*/
extern AUDIO_PLAYER* AudioPlayerNew(
	void* stream,
	size_t (*read_func)(void* buffer, size_t block_size, size_t block_num, void* src),
	int (*seek_func)(void* stream, long offset, int whence),
	long (*tell_func)(void* stream),
	SOUND_PROPERTY *meta_data,
	void (*on_destroy_func)(void*)
);

/*
* AudioPlayerDestroy֐
* Đp̃J
* 
* audio_player	: Đp̃f[^ւ̃|C^̃AhX
*/
extern void AudioPlayerDestroy(AUDIO_PLAYER** audio_player);

/*
* AudioPlayerPlaySound֐
* Đs
* 
* audio_player	: Đp̃f[^
* Ԃl
*	ĐI:1	Đp:0
*/
extern int AudioPlayerPlaySound(AUDIO_PLAYER* audio_player);

/*
* GetSoundMetaData֐
* f[^̃^f[^擾
* 
* stream	: f[^ւ̃|C^
* read_func	: f[^ǂݍݗp̊֐|C^
* seek_func	: f[^V[Np̊֐|C^
* tell_func	: f[^ʒu擾p̊֐|C^
*/
extern SOUND_PROPERTY* GetSoundMetaData(
	void* stream,
	size_t (*read_func)(void* buffer, size_t block_size, size_t block_num, void* src),
	int (*seek_func)(void* stream, long offset, int whence),
	long (*tell_func)(void* stream)
);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INCLUDED_AUDIO_PLAYER_H_
