#ifndef _INCLUDED_FILTER_H_
#define _INCLUDED_FILTER_H_

#include "types.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef void (*filter_func)(struct _DRAW_WINDOW* window, struct _LAYER** layers,
							uint16 num_layer, void* data);
typedef void (*selection_filter_func)(struct _DRAW_WINDOW* window, void* data);

// tB^[֐z̃CfbNX
typedef enum _eFILTER_FUNC_ID
{
	FILTER_FUNC_BLUR,
	FILTER_FUNC_MOTION_BLUR,
	FILTER_FUNC_BRIGHTNESS_CONTRAST,
	FILTER_FUNC_HUE_SATURATION,
	FILTER_FUNC_LUMINOSITY2OPACITY,
	FILTER_FUNC_COLOR2ALPHA,
	FILTER_FUNC_COLORIZE_WITH_UNDER,
	FILTER_FUNC_GRADATION_MAP,
	FILTER_FUNC_FILL_WITH_VECTOR,
	FILTER_FUNC_PERLIN_NOISE,
	FILTER_FUNC_FRACTAL,
	NUM_FILTER_FUNC
} eFILTER_FUNC_ID;

// tB^[֐|C^z
extern filter_func g_filter_funcs[NUM_FILTER_FUNC];
extern selection_filter_func g_selection_filter_funcs[NUM_FILTER_FUNC];

/*****************************************************
* ExecuteBlurFilter֐                              *
* ڂtB^s                               *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
extern void ExecuteBlurFilter(APPLICATION* app);

/*****************************************************
* ExecuteMotionBlurFilter֐                        *
* [VڂtB^s                     *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
extern void ExecuteMotionBlurFilter(APPLICATION* app);

/*****************************************************
* ExecuteChangeBrightContrastFilter֐              *
* 邳RgXgtB^s                   *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
extern void ExecuteChangeBrightContrastFilter(APPLICATION* app);

/*****************************************************
* ExecuteChangeHueSaturationFilter֐               *
* FEʓxtB^s                           *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
extern void ExecuteChangeHueSaturationFilter(APPLICATION* app);

/*****************************************************
* ExecuteLuminosity2OpacityFilter֐                *
* Px𓧖x֕ϊs                           *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
extern void ExecuteLuminosity2OpacityFilter(APPLICATION* app);

/*****************************************************
* ExecuteColor2AlphaFilter֐                       *
* wF𓧖x֕ϊs                         *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
extern void ExecuteColor2AlphaFilter(APPLICATION* app);

/*****************************************************
* ExecuteColorizeWithUnderFilter֐                 *
* ̃C[ŒFs                           *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
extern void ExecuteColorizeWithUnderFilter(APPLICATION* app);

/*****************************************************
* ExecuteGradationMapFilter֐                      *
* Of[V}bvs                         *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
extern void ExecuteGradationMapFilter(APPLICATION* app);

/*****************************************************
* ExecuteFillWithVectorLineFilter֐                *
* xNgC[𗘗pĉ̃C[hׂ   *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
extern void ExecuteFillWithVectorLineFilter(APPLICATION* app);

/*****************************************************
* ExecutePerlinNoiseFilter֐                       *
* p[mCYŉhs                       *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
extern void ExecutePerlinNoiseFilter(APPLICATION* app);

/*****************************************************
* ExecuteFractal֐                                 *
* tN^}`ŉhs                         *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
extern void ExecuteFractal(APPLICATION* app);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INCLUDED_FILTER_H_
