#ifndef _INLUCDED_INI_FILE_H_
#define _INLUCDED_INI_FILE_H_

#ifdef __cplusplus
extern "C" {
#endif

#define KEY_BUFF_SIZE 256		// L[ɂ閼O̍ő咷
#define SECTION_BUFF_SIZE 256	// ZNVɂ閼O̍ő咷
#define INI_ALLOC_SIZE 10		// TCYXV̍XVl

#define NUM_STRING_LEN 64	// lf[^̒̍̕ől

#define COMMENT_ON 1	// Rgł(tO̒l)
#define COMMENT_OFF 0	// RgłȂ(tO̒l)

// ǂݍ݂݂
typedef enum _eINI_MODE
{
	INI_READ,
	INI_WRITE
} eINI_MODE;

typedef struct _KEY
{
	char key_name[KEY_BUFF_SIZE];	// L[̖Oi[
	int hash;	// nbVl
	char *string;
	char comment_flag;	// Rgł邩ǂ̃tO
} KEY, *KEY_PTR;

typedef struct _SECTION
{
	// ZNV̖Oi[
	char section_name[SECTION_BUFF_SIZE];
	int hash;	// nbVl
	KEY_PTR key;	// L[̔z
	int key_count;	// L[̐
	int key_size;	// L[̃TCY
} SECTION, *SECTION_PTR;

typedef struct _INI_FILE
{
	SECTION_PTR section;	// init@C̓ei[
	int section_size;	// ZNṼTCY
	int section_count;	// ZNV̐
	void* io;			// init@Cf[^ւ̃t@C|C^
	char* file_path;	// init@Cւ̃pX

	// Jp̊֐ւ̃|C^
	void (*delete_func)(struct _INI_FILE *ini);
} INI_FILE, *INI_FILE_PTR;

// ֐̃vg^Cv錾
/************************************************
* CreateIniFile֐                             *
* init@C\̂̃̊mۂƏ *
*                                           *
* io		: init@Cf[^ւ̃|C^     *
* read_func	: ǂݍݗp̊֐                  *
* data_size	: init@C̃oCg             *
* mode		: ǂݍ݃[h݃[h  *
* Ԃl                                        *
*	ꂽ\̂̃AhX                *
************************************************/
extern INI_FILE_PTR CreateIniFile(
	void* io,
	size_t (*read_func)(void*, size_t, size_t, void*),
	size_t data_size,
	eINI_MODE mode
);

/********************************************************
* WriteIniFile֐                                      *
* init@Cɓeo                           *
*                                                   *
* ini			: init@CǗ\̂̃AhX *
* write_func	: op֐ւ̃|C^            *
* Ԃl                                                *
*	I(0)AȏI(0ȊO)                        *
********************************************************/
extern int WriteIniFile(
	INI_FILE_PTR ini,
	size_t (*write_func)(void*, size_t, size_t, void*)
);

/********************************************************
* IniFileGetString֐                               *
* init@C當擾                       *
*                                                   *
* ini			: init@CǗ\̂̃AhX *
* section_name	: ZNV̖O              *
* key_name		: L[̖O                    *
* ret			: i[z          *
* size			: ret̃TCY                           *
* Ԃl                                                *
*	̒(Ȃ0)           *
********************************************************/
extern long IniFileGetString(
	INI_FILE_PTR ini,
	const char* section_name,
	const char* key_name,
	char* ret,
	const long size
);

/********************************************************
* IniFileStrdup֐                                   *
* mۂĕm                          *
*                                                   *
* ini			: init@CǗ\̂̃AhX *
* section_name	: ZNV̖O              *
* key_name		: L[̖O                    *
* Ԃl                                                *
*	mۂ̃AhX(sNULL)              *
********************************************************/
extern char* IniFileStrdup(
	INI_FILE_PTR ini,
	const char* section_name,
	const char* key_name
);

/********************************************************
* IniFileGetInt֐                                     *
* init@C琔l擾                         *
*                                                   *
* ini			: init@CǗ\̂̃AhX *
* section_name	: ZNV̖O              *
* key_name		: L[̖O                    *
* Ԃl                                                *
*	L[ɏĂ鐔l(s͏0)               *
********************************************************/
extern int IniFileGetInt(
	INI_FILE_PTR ini,
	const char* section_name,
	const char* key_name
);

/********************************************************
* IniFileGetDouble֐                                  *
* init@C珬l擾                     *
*                                                   *
* ini			: init@CǗ\̂̃AhX *
* section_name	: ZNV̖O              *
* key_name		: L[̖O                    *
* Ԃl                                                *
*	L[ɏĂ鐔l(s͏0)               *
********************************************************/
extern double IniFileGetDouble(
	INI_FILE_PTR ini,
	const char* section_name,
	const char* key_name
);

/********************************************************
* IniFileGetArray֐                                   *
* init@C畡̐lf[^擾             *
*                                                   *
* ini			: init@CǗ\̂̃AhX *
* section_name	: ZNV̖O              *
* key_name		: L[̖O                    *
* array_ptr		: f[^z                  *
* array_size	: z̃TCY                          *
* Ԃl                                                *
*	I(0)AȏI(̒l)                       *
********************************************************/
extern int IniFileGetArray(
	INI_FILE_PTR ini,
	const char* section_name,
	const char* key_name,
	int* array_ptr,
	int array_size
);

/********************************************************
* IniFileAddString֐                                  *
* init@Cɕǉ                         *
*                                                   *
* ini			: init@CǗ\̂̃AhX *
* section_name	: ZNV̖O              *
* key_name		: L[̖O                    *
* str			: ǉ镶                        *
* Ԃl                                                *
*	I(0)AȏI(̒l)                       *
********************************************************/
extern int IniFileAddString(
	INI_FILE_PTR ini,
	const char* section_name,
	const char* key_name,
	const char* str
);

/*********************************************************
* IniFileAddInteger֐                                  *
* init@Cɐlǉ                            *
*                                                    *
* ini			: init@CǗ\̂̃AhX  *
* section_name	: ZNV̖O               *
* key_name		: L[̖O                     *
* num			: ǉ鐔l                           *
* radix			: l̃tH[}bg(10iA16iȂ) *
* Ԃl                                                 *
*	I(0)AȏI(̒l)                        *
*********************************************************/
extern int IniFileAddInteger(
	INI_FILE_PTR ini,
	const char* section_name,
	const char* key_name,
	const int num,
	const int radix
);

/********************************************************
* IniFileAddDouble֐                                  *
* init@Cɏf[^ǉ                     *
*                                                   *
* ini			: init@CǗ\̂̃AhX *
* section_name	: ZNV̖O              *
* key_name		: L[̖O                    *
* num			: ǉ鐔l                          *
* Ԃl                                                *
*	I(0)AȏI(̒l)                       *
********************************************************/
extern int IniFileAddDouble(
	INI_FILE_PTR ini,
	const char* section_name,
	const char* key_name,
	const double num
);

/********************************************************
* Change_INI_FILE_MODE֐                              *
* init@C̏݁Aǂݍ݂̃[h؂ւ   *
*                                                   *
* ini			: init@CǗ\̂̃AhX *
* Ԃl                                                *
*	I(0)AُI(̒l)                       *
********************************************************/
extern int Change_INI_FILE_MODE(INI_FILE_PTR ini, eINI_MODE mode);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INLUCDED_INI_FILE_H_
