#ifndef _INCLUDED_PATTERN_H_
#define _INCLUDED_PATTERN_H_

#include <gtk/gtk.h>
#include "types.h"

#ifdef __cplusplus
extern "C" {
#endif

// p^[̍E]A㉺]̃tO
typedef enum _PATTERN_FLAGS
{
	PATTERN_FLIP_HORIZONTALLY = 0x01,
	PATTERN_FLIP_VERTICALLY = 0x02
} PATTERN_FLAGS;

// p^[̃`l2̂Ƃ̃[h
typedef enum _PATTERN_MODE
{
	PATTERN_MODE_SATURATION,
	PATTERN_MODE_BRIGHTNESS,
	PATTERN_MODE_FORE_TO_BACK,
	PATTERN_MODE_NUM
} PATTERN_MODE;

#ifndef INCLUDE_WIN_DEFAULT_API
/****************************
* PATTERN\             *
* p^[f[^1̏ *
****************************/
typedef struct _PATTERN
{
	// 摜f[^̕AAs̃oCg
	gint32 width, height, stride;
	// 摜f[^̃`l
	uint8 channel;
	// 摜̃sNZf[^
	uint8* pixels;
} PATTERN;
#else
#include <wingdi.h>
#endif

/*************************
* PATTERNS\         *
* gp\ȃp^[ *
*************************/
typedef struct _PATTERNS
{
	// p^[ƃANeBuȃp^[
	PATTERN* patterns, *active_pattern;
	// Nbv{[h̃p^[
	PATTERN clip_board;
	// Nbv{[h̃p^[鎞̃tO
	int has_clip_board_pattern;
	// gp\ȃp^[̐
	int32 num_pattern;
	// RGBAɕϊp^[̃oCgf[^
	uint8* pattern_pixels;
	// `l2̂Ƃ̃}XNp
	uint8* pattern_mask;
	// RGBAϊ̈ꎞۑ
	uint8* pattern_pixels_temp;
	// p^[摜̍őoCg
	size_t pattern_max_byte;
	// p^[̊g嗦
	gdouble scale;
} PATTERNS;

// ֐̃vg^Cv錾
/*************************************************************
* InitializePatterns֐                                     *
* p^[                                           *
*                                                        *
* pattern			: p^[Ǘ\̂̃AhX *
* directory_path	: p^[t@ĈfBNgpX *
* buffer_size		: ݂̃obt@TCY                   *
*************************************************************/
extern void InitializePattern(PATTERNS* pattern, const char* directory_path, int* buffer_size);

/*********************************************************
* UpdateClipBoardPattern֐                             *
* Nbv{[h摜f[^oăp^[ɂ *
*                                                    *
* patterns	: p^[Ǘ\̂̃AhX         *
*********************************************************/
extern void UpdateClipBoardPattern(PATTERNS* patterns);

/*************************************************
* CreatePatternSurface֐                       *
* p^[hׂspCAIROT[tF[X쐬  *
*                                            *
* patterns	: p^[Ǘ\̂̃AhX *
* scale		: p^[̊g嗦                   *
* rgb		: ݂̕`F                       *
* back_rgb	: ݂̔wiF                       *
* flags		: E]A㉺]̃tO         *
* mode		: `l2̂Ƃ̍쐬[h  *
* flow		: p^[̔Zx                     *
* Ԃl                                         *
*	쐬T[tF[X                         *
*************************************************/
extern cairo_surface_t* CreatePatternSurface(
	PATTERNS* patterns,
	uint8 rgb[3],
	uint8 back_rgb[3],
	int flags,
	int mode,
	gdouble flow
);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INCLUDED_PATTERN_H_
