#ifndef _INCLUDED_REFERENCE_WINDOW_H_
#define _INCLUDED_REFERENCE_WINDOW_H_

#include <gtk/gtk.h>
#include "types.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _REFERENCE_IMAGE
{
	uint8 *pixels;
	int width, height, stride;
	uint8 channel;
	cairo_surface_t *surface_p;
	gdouble zoom;
	gdouble rev_zoom;
	GtkWidget *draw_area;
	GtkWidget *scroll;
	struct _APPLICATION *app;
} REFERENCE_IMAGE;

typedef struct _REFERENCE_WINDOW_DATA
{
	GtkWidget *window;
	GtkWidget *note_book;
	GtkWidget *scale;
	GtkAdjustment *scale_adjust;
	int16 num_image;
	int16 active_image;
	REFERENCE_IMAGE *images[32];
} REFERENCE_WINDOW_DATA;

typedef struct _REFERENCE_WINDOW
{
	gint window_x, window_y;		// EBhE̍W
	gint window_width;				// EBhE̕
	gint window_height;				// EBhE̍
	GtkWidget *menu_item;			// \/\؂ւ郁j[ACe
	REFERENCE_WINDOW_DATA *data;	// \摜̃f[^
	struct _APPLICATION *app;		// AvP[VǗ\̂̃AhX
} REFERENCE_WINDOW;

// ֐̃vg^Cv錾
/*********************************************************
* InitializeReferenceWindow֐                          *
* Qlp摜\EBhȄ                       *
*                                                    *
* reference	: Qlp摜\EBhȄ             *
* app		: AvP[VǗ\̂̃AhX *
*********************************************************/
extern void InitializeReferenceWindow(REFERENCE_WINDOW* reference, struct _APPLICATION* app);

/***************************************************************
* DisplayReferenceWindowMenuActivate֐                       *
* Qlp摜\EBhE\郁j[̃R[obN֐ *
*                                                          *
* menu_item	: j[ACeEBWFbg                     *
* app		: AvP[VǗ\̂̃AhX       *
***************************************************************/
extern void DisplayReferenceWindowMenuActivate(GtkWidget* menu_item, struct _APPLICATION* app);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INCLUDED_REFERENCE_WINDOW_H_
