#ifndef _INCLUDED_SCRIPT_H_
#define _INCLUDED_SCRIPT_H_

#include <gtk/gtk.h>
#include "application.h"
#include "lua/lua.h"
#include "memory_stream.h"
#include "types.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum _eSCRIPT_BRUSH_FLAGS
{
	SCRIPT_BRUSH_STARTED = 0x01
} eSCRIPT_BRUSH_FLAGS;

typedef struct _SCRIPT_BRUSH
{
	BRUSH_CORE *core;
	unsigned int flags;
	cairo_surface_t *brush_surface;
	cairo_surface_t *alpha_surface;
	char *image_path;
	uint8 *pixels;
	uint8 *alpha;
	uint16 blend_mode;
	uint8 channel;
	uint8 colorize_mode;
	FLOAT_T r;
	int width, height;
	int stride;
	FLOAT_T before_x, before_y;
	FLOAT_T zoom;
	FLOAT_T distance;
	FLOAT_T arg;
	cairo_surface_t *cursor_surface;
	uint8 *cursor_pixels;
} SCRIPT_BRUSH;

typedef struct _SCRIPT_HISTROY_DATA
{
	uint32 num_history;
	uint32 data_size;
	MEMORY_STREAM *data_stream;
} SCRIPT_HISTORY_DATA;

typedef struct _SCRIPT
{
	APPLICATION *app;
	DRAW_WINDOW *window;
	SCRIPT_BRUSH *brush_data;
	SCRIPT_HISTORY_DATA history;
	lua_State *state;
	GtkWidget *main_window;
	GtkWidget *debug_window;
	GtkWidget *debug_view;
	GtkTextBuffer *debug_buffer;
	LAYER *work[128];
	cairo_surface_t *surfaces[128];
	char *file_name;
	int num_work;
} SCRIPT;

// ֐̃vg^Cv錾
/*********************************************************
* CreateScript֐                                       *
* LuaXNvgsp̃f[^쐬                        *
*                                                    *
* app		: AvP[VǗ\̂̃AhX *
* file_path	: XNvgt@C̃pX                   *
* Ԃl                                                 *
*	ꂽ\̂̃AhX                         *
*********************************************************/
extern SCRIPT* CreateScript(APPLICATION* app, const char* file_path);

/***********************************************
* DeleteScript֐                             *
* LuaXNvgsp̃f[^폜            *
*                                          *
* script	: 폜f[^|C^̃AhX *
***********************************************/
extern void DeleteScript(SCRIPT** script);

/*************************************************
* RunScript֐                                  *
* XNvgs                           *
*                                            *
* script	: XNvgsp̍\̂̃AhX *
*************************************************/
extern void RunScript(SCRIPT* script);

/*************************************************
* ScriptBrushPatternNew֐                      *
* XNvguṼp^[쐬           *
*                                            *
* script	: XNvgsp̍\̂̃AhX *
*************************************************/
extern void ScriptBrushPatternNew(SCRIPT* script);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INCLUDED_SCRIPT_H_
