#ifndef _INCLUDED_TEXT_LAYER_H_
#define _INCLUDED_TEXT_LAYER_H_

#include <gtk/gtk.h>
#include "types.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum _eTEXT_STYLE
{
	TEXT_STYLE_NORMAL,
	TEXT_STYLE_ITALIC,
	TEXT_STYLE_OBLIQUE
} eTEXT_STYLE;

/*********************************
* eTEXT_LAYER_FLAGS񋓑        *
* eLXgC[̕\ptO *
*********************************/
typedef enum _eTEXT_LAYER_FLAGS
{
	TEXT_LAYER_VERTICAL = 0x01,	// c
	TEXT_LAYER_BOLD = 0x02,		// 
	TEXT_LAYER_ITALIC = 0x04,	// C^bN
	TEXT_LAYER_OBLIQUE = 0x08	// Α
} eTEXT_LAYER_FLAGS;

/*******************************
* TEXT_LAYER\             *
* eLXgC[̏i[ *
*******************************/
typedef struct _TEXT_LAYER
{
	GtkWidget* text_field;	// eLXgr[EBWFbg
	GtkTextBuffer* buffer;	// `eLXgobt@
	char* text;				// obt@oeLXg
	gdouble x, y;			// eLXg\̈捶̍W
	gdouble width, height;	// eLXg\̈̕A
	// hbO̊JnW
	gdouble drag_start_x, drag_start_y;
	int base_size;			// tHgTCY̔{
	gdouble font_size;		// \eLXg̃TCY
	int32 font_id;			// tHgt@CID
	uint8 color[3];			// \F
	uint32 flags;			// cÃtO
} TEXT_LAYER;

/*****************************************
* TEXT_LAYER_BASE_DATA\             *
* eLXgC[̊{(op) *
*****************************************/
typedef struct _TEXT_LAYER_BASE_DATA
{
	gdouble x, y;			// eLXg\̈捶̍W
	gdouble width, height;	// eLXg\̈̕A
	gdouble font_size;		// \eLXg̃TCY
	uint8 base_size;		// TCY̔{
	uint8 color[3];			// \F
	guint32 flags;			// cÃtO
} TEXT_LAYER_BASE_DATA;

/*********************************************
* CreateTextLayer֐                        *
* eLXgC[̃f[^mۂƏ *
*                                        *
* x			: C[XW                *
* y			: C[YW                *
* width		: C[̕                   *
* height	: C[̍                 *
* base_size	: TCY̔{               *
* font_size	: TCY                     *
* color		: F                         *
* flags		: eLXg\̃tO           *
* Ԃl                                     *
*	ꂽ\̂̃AhX             *
*********************************************/
extern TEXT_LAYER* CreateTextLayer(
	gdouble x,
	gdouble y,
	gdouble width,
	gdouble height,
	int base_size,
	gdouble font_size,
	int32 font_id,
	uint8 color[3],
	uint32 flags
);

/*****************************************************
* DeleteTextLayer֐                                *
* eLXgC[̃f[^폜                 *
*                                                *
* layer	: eLXgC[̃f[^|C^̃AhX *
*****************************************************/
extern void DeleteTextLayer(TEXT_LAYER** layer);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INCLUDED_TEXT_LAYER_H_
