#ifndef _INCLUDED_APPLICATION_H_
#define _INCLUDED_APPLICATION_H_

#include <gtk/gtk.h>
#include "audio_player.h"
#include "file_list_view.h"
#include "label.h"

typedef enum _eAPPLICATION_FLAGS
{
	APPLICATION_FLAG_PAUSE = 0x01,				// ꎞ~̃tO
	APPLICATION_FLAG_IN_PLAY_CONTROL = 0x02,
	APPLICATION_FLAG_SHUFFLE_PLAY = 0x04		// _Đ̃tO
} eAPPLICATION_FLAGS;

// ĐI̋
typedef enum _eAUDIO_PLAYER_PLAY_MODE
{
	APPLICATION_PLAYER_STOP_AT_END,			// 1ȍĐI~
	APPLICATION_PLAYER_ONE_LOOP,			// 1ȃ[vĐ
	APPLICATION_PLAYER_STOP_AT_LIST_END,	// XgI܂ōĐ
	APPLICATION_PLAYER_LIST_LOOP			// Xg[vĐ
} eAUDIO_PLAYER_PLAY_MODE;

typedef struct _APPLICATION_INITIALIZE
{
	// CEBhE̍W
	int window_x, window_y;
	// CEBhẼTCY
	int window_width, window_height;
} APPLICATION_INITIALIZE;

typedef struct _APPLICATION
{
	// Đp̃f[^
	struct
	{
		// Đ̃f[^
		AUDIO_PLAYER *audio_player;
		// t@Cւ̃|C^
		FILE *fp;
		// t@C̐΃pX
		char *file_path;
		// Đ̃{[
		FLOAT_T volume;
		// ݍĐ̉f[^̃pX
		SOUND_PROPERTY *current_play;
		// ĐI̋
		eAUDIO_PLAYER_PLAY_MODE play_mode;
		// _Đ̍Đ
		int *random_order;
		// _Đ̍Đʒu
		int random_position;
	} play_data;

	// GUĨf[^Q
	struct
	{
		// CEBhE
		GtkWidget *window;
		// Đ{^
		GtkWidget *play_button;
		// ꎞ~{^
		GtkWidget *pause_button;
		// vC[hݒ{^̉摜
		GtkWidget *play_mode_image;
		// {[Rg[
		GtkWidget *volume_control;
		// t@CXg̃XN[
		GtkWidget *scrolled_window;
		// t@CXg
		GtkWidget *list_view;
		// ŌĂяo֐ID
		gulong time_oud_id;
	} widgets;

	// t@CXg
	FILE_LIST file_list;

	// GUIɕ\镶
	LABEL *label;

	unsigned int flags;
} APPLICATION;

// ֐̃vg^Cv錾
/*
* ReadInitializeFile֐
* AvP[V̏f[^ǂݍ
* 
* app			: AvP[VǗ\
* initialize	: pf[^
* file_path		: f[^t@C̃pX
*/
extern void ReadInitializeFile(
	APPLICATION* app,
	APPLICATION_INITIALIZE* initialize,
	const char *file_path
);

/*
* WriteInitialize֐
* AvP[V̏f[^
* 
* app		: AvP[VǗ\
* file_path	: f[^t@C̃pX
*/
extern void WriteInitialize(APPLICATION* app, const char *file_path);

/*
* TimeOutCallBack֐
* 
* app	: AvP[VǗ\
* Ԃl
*	TRUE
*/
extern gboolean TimeOutCallBack(APPLICATION* app);

/*
* MenuBarNew֐
* j[o[쐬
* 
* label	: AvP[VŎgp郉x̕f[^
* app	: AvP[VǗ\
* Ԃl
*	j[o[EBWFbg
*/
extern GtkWidget* MenuBarNew(LABEL* label, APPLICATION* app);

/*
* ExecuteFileOpen֐
* ut@CJvs
* 
* app	: AvP[VǗ\
*/
extern void ExecuteFileOpen(APPLICATION* app);

/*
* ModelInitialize֐
* Xgr[̕\
* tree_view	: Xgr[EBWFbg
* label		: \镶
*/
extern void ModelInitialize(GtkWidget* tree_view, LABEL* label);


/*
* ListAppendSoundData֐
* f[^̏Xgɒǉ
* 
* app			: AvP[VǗ\
* property_data	: ̃^f[^
*/
extern void ListAppendSoundData(APPLICATION* app, SOUND_PROPERTY* property_data);

/*
* ListViewDoubleClicked֐
* t@CXg_uNbNꂽɌĂяo
* 
* tree_view	: Xgr[EBWFbg
* path		: ANeBuȃpX
* column	: ANeBuȗ
* app		: AvP[VǗ\
*/
extern void ListViewDoubleClicked(
	GtkWidget* tree_view,
	GtkTreePath* path,
	GtkTreeViewColumn* column,
	APPLICATION* app
);

/*
* GetDirectoryContents֐
* TufBNg܂ރfBNg̉f[^̏擾
* 
* app				: AvP[VǗ\
* directory_path	: `FbNfBNg̃pX
*/
extern void GetDirectoryContents(APPLICATION* app, const char* directory_path);

/*
* ResetRandomOrder֐
* _Đ̏Zbg
* 
* app	: AvP[VǗ\
*/
extern void ResetRandomOrder(APPLICATION* app);

#endif	// #ifndef _INCLUDED_APPLICATION_H_
