#ifndef _INCLUDED_BOKEH_H_
#define _INCLUDED_BOKEH_H_

#include "../../plug_in.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum _eBOKEH_SHAPE_TYPE
{
	BOKEH_SHAPE_TYPE_CIRCLE,
	BOKEH_SHAPE_TYPE_INFLATED_CIRCLE,
	BOKEH_SHAPE_TYPE_TRIANGLE,
	BOKEH_SHAPE_TYPE_SQUARE,
	BOKEH_SHAPE_TYPE_HEXAGON,
	BOKEH_SHAPE_TYPE_STAR
} eBOKEH_SHAPE_TYPE;

typedef struct _BOKEH_DATA
{
	eBOKEH_SHAPE_TYPE shape_type;
	double *temp_pixels;
	double *shape_pixels;
	double radius;
	double angle;
	float bloom;
	float bloom_threshold;
	int sides;
	int width,	height;
	int stride;
} BOKEH_DATA;

extern void InitializeBokeh(BOKEH_DATA* bokeh, LAYER* target);

extern void ReleaseBokeh(BOKEH_DATA* bokeh);

extern int Bokeh(
	BOKEH_DATA* bokeh,
	LAYER* target,
	int (*progress_func)(float rate, void* data),
	void* data
);

extern GtkWidget* BokehFilterSettingWidgetNew(BOKEH_DATA* bokeh, LAYER* target);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INCLUDED_BOKEH_H_
