#ifndef _INCLUDED_EFFECT_H_
#define _INCLUDED_EFFECT_H_

#include "../../plug_in.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum _eEFFECT_TYPE
{
	EFFECT_TYPE_BOKEH,
	EFFECT_TYPE_UNSHARP_MASK,
	NUM_EFFECT_TYPE
} eEFFECT_TYPE;

typedef struct _EFFECT
{
	eEFFECT_TYPE type;
	LAYER *target;
	void *effect_data;
	GtkWidget *box;
	GtkWidget *setting;
	gboolean canceled;
	float next;
} EFFECT;

extern void InitializeEffectFilter(EFFECT* effect, LAYER* target);

extern GtkWidget* EffectSettingWidgetNew(EFFECT* effect);

extern int ApplyEffectFilter(EFFECT* effect);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INCLUDED_EFFECT_H_
