#ifndef _INCLUDED_FFT_H_
#define _INCLUDED_FFT_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _FFT_DATA
{
	float *weight1;
	float *weight2;
	float *weight3;
} FFT_DATA;

extern void InitializeFFT(FFT_DATA* fft, int log_n);

extern void ReleaseFFT(FFT_DATA* fft);

extern void FastFourierTransform1D(
	FFT_DATA* fft,
	float* real,
	float* image,
	int log_n,
	int n,
	int direction
);

extern void FastFourierTransform2D(
	FFT_DATA* fft,
	float* real,
	float* image,
	int columns,
	int rows,
	int direction
);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INCLUDED_FFT_H_
