#ifndef _INCLDUED_IMAGE_READ_WRITE_H_
#define _INCLDUED_IMAGE_READ_WRITE_H_

#include <stdio.h>
#include <gtk/gtk.h>
#include "types.h"
#include "memory_stream.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum _eIMAGE_RW_FLAGS
{
	IMAGE_COMPRESS_PNG = 0x01	// PNGk
} eIMAGE_RW_FRAGS;

typedef enum _eIMAGE_DATA_TYPE
{
	IMAGE_DATA_RGB,
	IMAGE_DATA_RGBA,
	IMAGE_DATA_CMYK
} eIMAGE_DATA_TYPE;

// ֐̃vg^Cv錾
/*****************************************************************
* DecodeImageData֐                                            *
* ̉摜f[^fR[h                             *
*                                                            *
* data				: 摜f[^                                 *
* data_size			: 摜f[^̃oCg                       *
* file_type			: 摜̃^Cv\(:PNGȂ".png") *
* width				: 摜̊̕i[                           *
* height			: 摜̍̊i[                         *
* channel			: 摜`l̊i[                   *
* resolution		: 摜𑜓x̊i[                         *
* icc_profile_name	: ICCvt@C̖O̊i[              *
* icc_profile_data	: ICCvt@C̃f[^̊i[            *
* icc_profile_size	: ICCvt@C̃f[^TCY̊i[      *
* Ԃl                                                         *
*	fR[hsNZf[^                                   *
*****************************************************************/
extern uint8* DecodeImageData(
	uint8* data,
	size_t data_size,
	const char* file_type,
	int* width,
	int* height,
	int* channel,
	int* resolution,
	char** icc_profile_name,
	uint8** icc_profile_data,
	uint32* icc_profile_size
);

/***********************************************************
* ReadPNGStream֐                                        *
* PNGC[Wf[^ǂݍ                              *
*                                                      *
* stream	: f[^Xg[                             *
* read_func	: ǂݍݗp̊֐|C^                     *
* width		: C[W̕i[AhX               *
* height	: C[W̍i[AhX             *
* stride	: C[Ẅs̃oCgi[AhX *
* Ԃl                                                   *
*	sNZf[^                                         *
***********************************************************/
extern uint8* ReadPNGStream(
	void* stream,
	stream_func_t read_func,
	gint32* width,
	gint32* height,
	gint32* stride
);

/**************************************************************************
* ReadPNGHeader֐                                                       *
* PNGC[W̃wb_ǂݍ                                       *
*                                                                     *
* stream	: f[^Xg[                                            *
* read_func	: ǂݍݗp̊֐|C^                                    *
* width		: C[W̕i[AhX                              *
* height	: C[W̍i[AhX                            *
* stride	: C[Ẅs̃oCgi[AhX                *
* dpi		: C[W̉𑜓x(DPI)i[AhX                     *
* icc_profile_name	: ICCvt@C̖O󂯂|C^               *
* icc_profile_data	: ICCvt@C̃f[^󂯂|C^             *
* icc_profile_size	: ICCvt@C̃f[^̃oCgi[AhX *
**************************************************************************/
extern void ReadPNGHeader(
	void* stream,
	stream_func_t read_func,
	gint32* width,
	gint32* height,
	gint32* stride,
	int32* dpi,
	char** icc_profile_name,
	uint8** icc_profile_data,
	uint32* icc_profile_size
);

/**************************************************************************
* ReadPNGDetailData֐                                                   *
* PNGC[Wf[^ڍ׏tœǂݍ                               *
*                                                                     *
* stream	: f[^Xg[                                            *
* read_func	: ǂݍݗp̊֐|C^                                    *
* width		: C[W̕i[AhX                              *
* height	: C[W̍i[AhX                            *
* stride	: C[Ẅs̃oCgi[AhX                *
* dpi		: C[W̉𑜓x(DPI)i[AhX                     *
* icc_profile_name	: ICCvt@C̖O󂯂|C^               *
* icc_profile_data	: ICCvt@C̃f[^󂯂|C^             *
* icc_profile_size	: ICCvt@C̃f[^̃oCgi[AhX *
* Ԃl                                                                  *
*	sNZf[^                                                        *
**************************************************************************/
extern uint8* ReadPNGDetailData(
	void* stream,
	stream_func_t read_func,
	gint32* width,
	gint32* height,
	gint32* stride,
	int32* dpi,
	char** icc_profile_name,
	uint8** icc_profile_data,
	uint32* icc_profile_size
);

/*********************************************
* WritePNGStream֐                         *
* PNG̃f[^Xg[ɏ          *
*                                        *
* stream		: f[^Xg[           *
* write_func	: ݗp̊֐|C^   *
* pixels		: sNZf[^             *
* width			: 摜̕                   *
* height		: 摜̍                 *
* stride		: 摜f[^s̃oCg *
* channel		: 摜̃`l         *
* interlace		: C^[[X̗L       *
* compression	: kx                 *
*********************************************/
extern void WritePNGStream(
	void* stream,
	stream_func_t write_func,
	void (*flush_func)(void*),
	uint8* pixels,
	int32 width,
	int32 height,
	int32 stride,
	uint8 channel,
	int32 interlace,
	int32 compression
);

/********************************************************
* WritePNGDetailData֐                                *
* PNG̃f[^ڍ׏tŃXg[ɏ       *
*                                                   *
* stream			: f[^Xg[                  *
* write_func		: ݗp̊֐|C^          *
* pixels			: sNZf[^                    *
* width				: 摜̕                          *
* height			: 摜̍                        *
* stride			: 摜f[^s̃oCg        *
* channel			: 摜̃`l                *
* interlace			: C^[[X̗L              *
* compression		: kx                        *
* dpi				: 𑜓x(DPI)                       *
* icc_profile_name	: ICCvt@C̖O             *
* icc_profile_data	: ICCvt@C̃f[^           *
* icc_profile_data	: ICCvt@C̃f[^̃oCg *
********************************************************/
extern void WritePNGDetailData(
	void* stream,
	stream_func_t write_func,
	void (*flush_func)(void*),
	uint8* pixels,
	int32 width,
	int32 height,
	int32 stride,
	uint8 channel,
	int32 interlace,
	int32 compression,
	int32 dpi,
	char* icc_profile_name,
	uint8* icc_profile_data,
	uint32 icc_profile_size
);

/********************************************************************
* ReadJpegHeader֐                                                *
* JPEG̃wb_ǂݍ                                        *
*                                                               *
* system_file_path	: OS̃t@CVXeɑt@CpX      *
* width				: 摜̕f[^̓ǂݍݐ                    *
* height			: 摜̍f[^̓ǂݍݐ                  *
* resolution		: 摜̉𑜓xf[^̓ǂݍݐ                *
* icc_profile_data	: ICCvt@C̃f[^󂯂|C^       *
* icc_profile_size	: ICCvt@C̃f[^̃oCg̓ǂݍݐ *
********************************************************************/
extern void ReadJpegHeader(
	const char* system_file_path,
	int* width,
	int* height,
	int* resolution,
	uint8** icc_profile_data,
	int32* icc_profile_size
);

/********************************************************************
* ReadJpegStream֐                                                *
* JPEG̃f[^ǂݍ݁AfR[h                              *
*                                                               *
* stream			: ǂݍ݌                                    *
* read_func			: ǂݍ݂Ɏg֐|C^                    *
* data_size			: JPEG̃f[^TCY                            *
* width				: 摜̕f[^̓ǂݍݐ                    *
* height			: 摜̍f[^̓ǂݍݐ                  *
* channel			: 摜f[^̃`l                      *
* resolution		: 摜̉𑜓xf[^̓ǂݍݐ                *
* icc_profile_data	: ICCvt@C̃f[^󂯂|C^       *
* icc_profile_size	: ICCvt@C̃f[^̃oCg̓ǂݍݐ *
* Ԃl                                                            *
*	fR[hsNZf[^(sNULL)                      *
********************************************************************/
extern uint8* ReadJpegStream(
	void* stream,
	stream_func_t read_func,
	size_t data_size,
	int* width,
	int* height,
	int* channel,
	int* resolution,
	uint8** icc_profile_data,
	int32* icc_profile_size
);

/****************************************************************
* WriteJpegFile֐                                             *
* JPEG`ŉ摜f[^o                                *
*                                                           *
* system_file_path	: OS̃t@CVXeɑt@CpX  *
* pixels			: sNZf[^                            *
* width				: 摜f[^̕                            *
* height			: 摜f[^̍                          *
* channel			: 摜̃`l                        *
* data_type			: sNZf[^̌`(RGB or CMYK)         *
* quality			: JPEG摜̉掿                            *
* optimize_coding	: œKGR[h̗L                    *
* icc_profile_data	: ߍICCvt@C̃f[^           *
*						(ߍ܂ȂNULL)                  *
* icc_profile_size	: ߍICCvt@C̃f[^̃oCg *
* resolution		: 𑜓x(dpi)                               *
****************************************************************/
extern void WriteJpegFile(
	const char* system_file_path,
	uint8* pixels,
	int width,
	int height,
	int channel,
	eIMAGE_DATA_TYPE data_type,
	int quality,
	int optimize_coding,
	void* icc_profile_data,
	int icc_profile_size,
	int resolution
);

/**********************************************
* ReadTgaStream֐                           *
* TGAt@C̓ǂݍ(KvɉăfR[h) *
*                                         *
* stream	: ǂݍ݌                      *
* read_func	: ǂݍ݂Ɏg֐|C^      *
* data_size	: 摜f[^̃oCg            *
* width		: 摜̕                        *
* height	: 摜̍                      *
* channel	: 摜̃`l              *
* Ԃl                                      *
*	sNZf[^(sNULL)              *
**********************************************/
extern uint8* ReadTgaStream(
	void* stream,
	stream_func_t read_func,
	size_t data_size,
	int* width,
	int* height,
	int* channel
);

/*******************************************************
* ReadBmpStream֐                                    *
* BMPt@C̃sNZf[^ǂݍ                *
*                                                  *
* stream		: 摜f[^̃Xg[               *
* read_func		: Xg[ǂݍݗp̊֐|C^   *
* seek_func		: Xg[̃V[NɎg֐|C^ *
* data_size		: 摜f[^̃oCg                 *
* width			: 摜̊̕i[                     *
* height		: 摜̍̊i[                   *
* channel		: 摜̃`l̊i[           *
* resolution	: 摜̉𑜓x(dpi)̊i[            *
* Ԃl                                               *
*	sNZf[^(sNULL)                       *
*******************************************************/
extern uint8* ReadBmpStream(
	void* stream,
	stream_func_t read_func,
	seek_func_t seek_func,
	size_t data_size,
	int* width,
	int* height,
	int* channel,
	int* resolution
);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INCLDUED_IMAGE_READ_WRITE_H_
