#ifndef _INCLUDED_BEZIER_H_
#define _INCLUDED_BEZIER_H_

#include "vector.h"
#include "draw_window.h"

#ifdef __cplusplus
extern "C" {
#endif

/***************************
* BEZIER_POINT\       *
* xWFȐł̐_W *
***************************/
typedef struct _BEZIER_POINT
{
	FLOAT_T x, y;
} BEZIER_POINT;

// ֐̃vg^Cv錾
/******************************************************
* MakeBezier3EdgeControlPoint֐                     *
* 3_̍W3xWFȐ̒[_ł̍W肷  *
*                                                 *
* src		: xWFȐʂW                    *
* control	: 2xWFȐ̐_LAhX *
******************************************************/
extern void MakeBezier3EdgeControlPoint(BEZIER_POINT* src, BEZIER_POINT* control);

/*************************************************
* CalcBezier2֐                                *
* 2xWFȐ̔}ϐtɂWvZ *
*                                            *
* points	: xWFȐ̐_                 *
* t			: }ϐt                          *
* dest		: Wf[^LAhX       *
*************************************************/
extern void CalcBezier2(BEZIER_POINT* points, FLOAT_T t, BEZIER_POINT* dest);

extern void MakeBezier3ControlPoints(BEZIER_POINT* src, BEZIER_POINT* controls);

extern void CalcBezier3(BEZIER_POINT* points, FLOAT_T t, BEZIER_POINT* dest);

extern void StrokeBezierLine(
	DRAW_WINDOW* window,
	VECTOR_LINE* line,
	VECTOR_LAYER_RECTANGLE* rect
);

extern void StrokeBezierLineClose(
	DRAW_WINDOW* window,
	VECTOR_LINE* line,
	VECTOR_LAYER_RECTANGLE* rect
);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INCLUDED_BEZIER_H_
