#ifndef _INCLUDED_SELECTION_AREA_H_
#define _INCLUDED_SELECTION_AREA_H_

#include <gtk/gtk.h>
#include "layer.h"
#include "types.h"
#include "configure.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum _eSELECT_FUZZY_DIRECTION
{
	FUZZY_SELECT_DIRECTION_QUAD,
	FUZZY_SELECT_DIRECTION_OCT
} eSELECT_FUZZY_DIRECTION;

typedef struct _SELECTION_SEGMENT_POINT
{
	int32 x, y;
} SELECTION_SEGMENT_POINT;

typedef struct _SELECTION_SEGMENT
{
	SELECTION_SEGMENT_POINT* points;
	int32 num_points;
} SELECTION_SEGMENT;

typedef struct _SELECTION_AREA
{
	int32 min_x, min_y, max_x, max_y;
#ifdef OLD_SELECTION_AREA
	int32 num_area;
	int16 index;
	SELECTION_SEGMENT* area_data;
#else
	cairo_surface_t *surface_p;
	int stride;
	int index;
	uint8 *pixels;
#endif
} SELECTION_AREA;

// I͈͕ҏWp̊֐|C^z
extern void (*g_blend_selection_funcs[])(LAYER* work, LAYER* selection);

typedef enum _eSELECTION_BLEND_MODE
{
	SELECTION_BLEND_NORMAL,
	SELECTION_BLEND_SOURCE,
	SELECTION_BLEND_COPY,
	SELECTION_BLEND_MINUS
} eSELECTION_BLEND_MODE;

// ֐̃vg^Cv錾
extern gboolean UpdateSelectionArea(SELECTION_AREA* area, LAYER* selection, LAYER* temp);

/***************************************************************
* LaplacianFilter֐                                          *
* vVAtB^ŃO[XP[񂩂GbW𒊏o *
*                                                          *
* pixels		: O[XP[̃C[W                     *
* width			: 摜̕                                     *
* height		: 摜̍                                   *
* stride		: 1s̃oCg                              *
* write_buff	: GbWf[^oobt@               *
***************************************************************/
extern void LaplacianFilter(
	uint8* pixels,
	int width,
	int height,
	int stride,
	uint8* write_buff
);

extern void DrawSelectionArea(
	SELECTION_AREA* area,
	struct _DRAW_WINDOW* window
);

extern void AddSelectionAreaChangeHistory(
	struct _DRAW_WINDOW* window,
	const gchar* tool_name,
	int32 min_x,
	int32 min_y,
	int32 max_x,
	int32 max_y
);

extern void DetectSameColorArea(
	LAYER* target,
	uint8* buff,
	uint8* temp_buff,
	int32 start_x,
	int32 start_y,
	uint8 *color,
	uint8 channel,
	int16 threshold,
	int32* min_x,
	int32* min_y,
	int32* max_x,
	int32* max_y,
	eSELECT_FUZZY_DIRECTION direction
);

/*****************************************
* AddSelectionAreaByColor֐            *
* FIs                         *
*                                    *
* target	: FrsC[       *
* buff		: I͈͂Lobt@ *
* color		: IF                 *
* threshold	: I𔻒f臒l             *
* min_x		: I͈͂̍ŏXW      *
* min_y		: I͈͂̍ŏYW      *
* max_x		: I͈͂̍őXW      *
* max_y		: I͈͂̍őYW      *
* Ԃl                                 *
*	I͈͗L:1 I͈͖:0        *
*****************************************/
extern int AddSelectionAreaByColor(
	LAYER* target,
	uint8* buff,
	uint8* color,
	int channel,
	int32 threshold,
	int32* min_x,
	int32* min_y,
	int32* max_x,
	int32* max_y
);

/*****************************************
* ExtendSelectionAreaOneStep֐         *
* I͈͂1sNZg傷            *
*                                    *
* select	: I͈͂Ǘ郌C[ *
* temp		: ꎞۑp̃C[       *
*****************************************/
extern void ExtendSelectionAreaOneStep(LAYER* select, LAYER* temp);

/*****************************************
* RecuctSelectionAreaOneStep֐         *
* I͈͂1sNZk            *
*                                    *
* select	: I͈͂Ǘ郌C[ *
* temp		: ꎞۑp̃C[       *
*****************************************/
extern void ReductSelectionAreaOneStep(LAYER* select, LAYER* temp);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INCLUDED_SELECTION_AREA_H_
