#ifndef _INCLUDED_SMOOTHER_H_
#define _INCLUDED_SMOOTHER_H_

#include <gtk/gtk.h>
#include "types.h"

#ifdef __cplusplus
extern "C" {
#endif

// u␳Ɏgpf[^_̍ő吔
#define SMOOTHER_POINT_BUFFER_SIZE 30
// u␳̓Kp̍ől
#define SMOOTHER_RATE_MAX 100
// u␳̕
typedef enum _eSMOOTH_METHOD
{
	SMOOTH_GAUSSIAN,
	SMOOTH_AVERAGE
} eSMOOTH_METHOD;

/***********************
* SMOOTHER_POINT\ *
* u␳p̍W   *
***********************/
typedef struct _SMOOTHER_POINT
{
	FLOAT_T x, y;
} SMOOTHER_POINT;

/*******************
* SMOOTHER\   *
* u␳̏ *
*******************/
typedef struct _SMOOTHER
{
	// u␳ɎgpWf[^
	SMOOTHER_POINT buffer[SMOOTHER_POINT_BUFFER_SIZE];
	// Ou␳Ƃ̍Wf[^
	SMOOTHER_POINT before_point;
	// Ōɕ`悵W
	SMOOTHER_POINT last_draw_point;
	// ϒlvZp̍vl
	SMOOTHER_POINT sum;
	// f[^
	FLOAT_T velocity[SMOOTHER_POINT_BUFFER_SIZE];
	// ␳銄
	FLOAT_T rate;
	// z̃CfbNX
	int index;
	// f[^_
	int num_data;
	// gpf[^_
	int num_use;
	// Ou␳Ƃ̎
	guint last_time;
	// u␳̕
	int mode;
} SMOOTHER;

// ֐̃vg^Cv錾
#define INIT_SMOOTHER(SMOOTHER) (SMOOTHER).index = 0, (SMOOTHER).num_data=0

/********************************************
* Smooth֐                                *
* u␳s                          *
*                                       *
* smoother	: u␳̃f[^            *
* x			: ݂xWB␳̒l *
* y			: ݂yWB␳̒l *
* this_time	: u␳Jn        *
* zoom_rate	: `̈̊gk          *
********************************************/
extern void Smooth(
	SMOOTHER* smoother,
	FLOAT_T *x,
	FLOAT_T *y,
	guint this_time,
	FLOAT_T zoom_rate
);

/*********************************************
* AddAverageSmoothPoint֐                  *
* Wωɂu␳Ƀf[^_ǉ *
*                                        *
* smoother	: u␳̃f[^             *
* x			: }EXXW                  *
* y			: }EXYW                  *
* pressure	: M                           *
* zoom_rate	: `̈̊gk           *
* Ԃl                                     *
*	uV̕`s:TRUE	sȂ:FALSE   *
*********************************************/
extern gboolean AddAverageSmoothPoint(
	SMOOTHER* smoother,
	FLOAT_T* x,
	FLOAT_T* y,
	FLOAT_T* pressure,
	FLOAT_T zoom_rate
);

/****************************************************
* AverageSmoothFlush֐                            *
* ωɂu␳̎cobt@1o *
*                                               *
* smoother	: u␳̏                      *
* x			: }EXXW                         *
* y			: }EXYW                         *
* pressure	: M                                  *
* Ԃl                                            *
*	obt@̎c薳:TRUE	cL:FALSE          *
****************************************************/
extern gboolean AverageSmoothFlush(
	SMOOTHER* smoother,
	FLOAT_T* x,
	FLOAT_T* y,
	FLOAT_T* pressure
);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INCLUDED_SMOOTHER_H_
