#ifndef _INCLUDED_TRANSFORM_H_
#define _INCLUDED_TRANSFORM_H_

#include "application.h"

#ifdef __cplusplus
extern "C" {
#endif

/***********************
* TRANSFORM_DATA\ *
* ό`̃f[^     *
***********************/
typedef struct _TRANSFORM_DATA
{
	int32 x, y;						// ό`̈̍̍W
	int32 width, height;			// ό`̈̕ƍ
	int stride;						// 摜f[^1s̃oCg
	uint8 **source_pixels;			// ό`̈̃sNZf[^
	uint8 **before_pixels;			// ό`ÕsNZf[^
	LAYER **layers;					// ό`sC[
	uint16 num_layers;				// ό`sC[̐
	uint16 trans_point;				// I𒆂̃|Cg
	uint8 selected_mode;			// IĂ郂[h
	uint8 trans_mode;				// ό`[h
	uint8 trans_type;				// ό`@
	uint8 flags;					// ㉺EE]̃tO
	FLOAT_T move_x, move_y;			// AtBϊł̈ړ̍W
	FLOAT_T angle;					// AtBϊł̉]
	gdouble before_x, before_y;		// }EX̍WL
	FLOAT_T before_angle;			// ȌԂł̊px
	FLOAT_T trans[8][2];			// ό`Ŏw肳Ă4_̍W
	// ˉeϊs͈
	int min_x[4], max_x[4], min_y[4], max_y[4];
} TRANSFORM_DATA;

typedef enum _eTRANSFORM_FLAGS
{
	TRANSFORM_REVERSE_HORIZONTALLY = 0x01,
	TRANSFORM_REVERSE_VERTICALLY = 0x02
} eTRANSFORM_FLAGS;

typedef enum _eTRANSFORM_POINT
{
	TRANSFORM_LEFT_UP,
	TRANSFORM_LEFT,
	TRANSFORM_LEFT_DOWN,
	TRANSFORM_DOWN,
	TRANSFORM_RIGHT_DOWN,
	TRANSFORM_RIGHT,
	TRANSFORM_RIGHT_UP,
	TRANSFORM_UP,
	TRANSFORM_POINT_NONE
} eTRANSFORM_POINT;

typedef enum _eTRANSFORM_MODE
{
	TRANSFORM_FREE,
	TRANSFORM_SCALE,
	TRANSFORM_FREE_SHAPE,
	TRANSFORM_ROTATE,
	TRANSFORM_MOVE
} eTRANSFORM_MODE;

typedef enum _eTRANSFORM_TYPE
{
	TRANSFORM_PROJECTION,
	TRANSFORM_PATTERN
} eTRANSFORM_TYPE;

// ֐̃vg^Cv錾
/*************************************
* CreateTransformData֐            *
* ό`p̃f[^쐬       *
*                                *
* window	: ό`s`̈ *
*************************************/
extern TRANSFORM_DATA *CreateTransformData(DRAW_WINDOW* window);

/***************************************
* DeleteTransformData֐              *
* ό`p̃f[^J             *
*                                  *
* transform	: Jf[^̃AhX *
***************************************/
extern void DeleteTransformData(TRANSFORM_DATA** transform);

/***********************************************
* Transform֐                                *
* ό`s                               *
*                                          *
* transform			: ό`p̃f[^       *
* projection_param	: ˉeϊp̃p[^[ *
***********************************************/
extern void Transform(TRANSFORM_DATA* transform);

/***********************************************
* ProjectionTransform֐                      *
* ˉeό`s                           *
*                                          *
* transform			: ό`p̃f[^       *
* projection_param	: ˉeϊp̃p[^[ *
***********************************************/
extern void ProjectionTransform(TRANSFORM_DATA* transform, FLOAT_T projection_param[4][9]);

/*****************************************************
* ExecuteTransform֐                               *
* AvP[Vj[̕ό`̌Ăяo   *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
*****************************************************/
extern void ExecuteTransform(APPLICATION* app);

/*******************************************************
* ExecuteProjection֐                                *
* AvP[Vj[̎ˉeϊ̌Ăяo *
*                                                  *
* app	: AvP[VǗ\̂̃AhX   *
*******************************************************/
extern void ExecuteProjection(APPLICATION* app);

extern void TransformButtonPress(TRANSFORM_DATA* transform, gdouble x, gdouble y);

extern void DisplayTransform(DRAW_WINDOW *window);

/***********************************************
* TransformMotionNotifyCallBack֐            *
* ό`̃}EXhbÕR[obN֐ *
*                                          *
* window	: `̈̏                   *
* transform	: ό`̏                   *
* x			: }EXXW                    *
* y			: }EXYW                    *
* state		: }EXEL[{[h̏         *
***********************************************/
extern void TransformMotionNotifyCallBack(
	DRAW_WINDOW* window,
	TRANSFORM_DATA* transform,
	gdouble x,
	gdouble y,
	void* state
);

/*****************************************************
* CreateTransformDetailUI֐                        *
* ό`UIEBWFbg쐬                   *
*                                                *
* app	: AvP[VǗ\̂̃AhX *
* Ԃl                                             *
*	쐬UIEBWFbg                           *
*****************************************************/
extern GtkWidget* CreateTransformDetailUI(APPLICATION* app);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _INCLUDED_TRANSFORM_H_
