// Visual Studio 2005ȍ~ł͌ÂƂ֐gp̂
	// xoȂ悤ɂ
#if defined _MSC_VER && _MSC_VER >= 1400
# define _CRT_SECURE_NO_DEPRECATE
#endif

#include <string.h>
#include <zlib.h>
#include "../../plug_in.h"
#include "../../utils.h"
#include "../../memory_stream.h"
#include "../../image_read_write.h"
#include "graph.h"
#include "texturize.h"

typedef struct _PLUG_IN_WIDGETS
{
	PLUG_IN_VALUES *values;
	GtkWidget *progress;
	int cancel;
	float last_update;
} PLUG_IN_WIDGETS;

static int DummyProgress(float progress, void* data)
{
	return 0;
}

int Render(
	DRAW_WINDOW* canvas,
	LAYER* target,
	PLUG_IN_VALUES* values,
	int (*progress_func)(float progress, void* data),
	void* data
)
{
	int width_out, height_out, width_in, height_in;
	int channels;

	int i, x, y;
	uint8 *patch;
	uint8 *image;

	uint8 *coupe_h_here;
	uint8 *coupe_h_west;
	uint8 *coupe_v_here;
	uint8 *coupe_v_north;

	uint8 **rempli;

	int cursor_position[2];
	int patch_position[2];
	int x_offset_minimum, y_offset_minimum;
	int x_offset_maximum, y_offset_maximum;

	int result = 0;
	int compter = 0;
	float progress;

	width_out = target->width;
	height_out = target->height;
	channels = target->channel;

	if(progress_func == NULL)
	{
		progress_func = DummyProgress;
	}

	if((canvas->flags & DRAW_WINDOW_HAS_SELECTION_AREA) != 0)
	{
		int start_x,	start_y;
		start_x = canvas->selection_area.min_x;
		start_y = canvas->selection_area.min_y;
		width_in = canvas->selection_area.max_x - canvas->selection_area.min_x;
		height_in = canvas->selection_area.max_y - canvas->selection_area.min_y;

		patch = (uint8*)malloc(width_in * height_in * channels);

		for(y=0; y<height_in; y++)
		{
			for(x=0; x<width_in; x++)
			{
				for(i=0; i<channels; i++)
				{
					patch[(y*width_in + x)*channels + i] =
						(canvas->active_layer->pixels[(start_y+y)*canvas->active_layer->stride + (start_x + x) * canvas->active_layer->channel + i]
							* canvas->selection->pixels[(start_y+y)*canvas->selection->stride + (start_x + x) * canvas->selection->channel]) / 255;
				}
			}
		}
	}
	else
	{
		width_out = width_in = canvas->width;
		height_out = height_in = canvas->height;

		patch = (uint8*)malloc(width_in * height_in * channels);

		(void)memcpy(patch, canvas->active_layer->pixels,
			width_in * height_in * channels);
	}

	x_offset_minimum = MIN(values->overlap, width_in - 1);
	y_offset_minimum = MIN(values->overlap, height_in - 1);
	x_offset_maximum = CLAMP(20, x_offset_minimum/3, width_in -1);
	y_offset_maximum = CLAMP(20, y_offset_minimum/3, height_in - 1);

	image =target->pixels;
	rempli = RempliNew(width_out, height_out);

	coupe_h_here  = (uint8*)calloc(sizeof(uint8), width_out * height_out * channels);
	coupe_h_west  = (uint8*)calloc(sizeof(uint8), width_out * height_out * channels);
	coupe_v_here  = (uint8*)calloc(sizeof(uint8), width_out * height_out * channels);
	coupe_v_north = (uint8*)calloc(sizeof(uint8), width_out * height_out * channels);

	for(y=0; y<height_in; y++)
	{
		(void)memcpy(&target->pixels[y*target->stride],
			&patch[y*width_in*channels], width_in*channels);
	}

	for(x = 0; x < width_in; x++)
	{
		for(y = 0; y < height_in; y++)
		{
			rempli[x][y] = 1;
			compter++;
		}
	}

	cursor_position[0] = 0; cursor_position[1] = 0;

	//while((compter = CompterRemplis(rempli,width_out,height_out)) < (width_out * height_out))
	while(compter < (width_out * height_out) && result == 0)
	{
		if(PixelRemplir(rempli, width_out, height_out, cursor_position) == NULL)
		{
			break;
		}

		OffsetOptimal (patch_position,
			image, patch,
			width_in, height_in, width_out, height_out,
			cursor_position[0] - x_offset_minimum,
			cursor_position[1] - y_offset_minimum,
			cursor_position[0] - x_offset_maximum,
			cursor_position[1] - y_offset_maximum,
			channels,
			rempli,
			values->make_tileable
		);

		DecoupeGraph(patch_position,
			width_out, height_out, width_in, height_in,
			channels,
			rempli,
			image,
			patch,
			coupe_h_here, coupe_h_west, coupe_v_here, coupe_v_north,
			&compter,
			values->make_tileable,
			values->reverse,
			NULL
		);

		progress = (float)compter / ((float)(width_out * height_out));
		result = progress_func(progress, data);
	}

	free(rempli[0]);
	free(rempli);
	free(patch);
	free(coupe_h_here);
	free(coupe_h_west);
	free(coupe_v_here);
	free(coupe_v_north);

	return result;
}

static int Progress(float rate, PLUG_IN_WIDGETS* widgets)
{
	if(rate - widgets->last_update > 0.02f)
	{
		char text[128];
		(void)sprintf(text, "%d%%", (int)(rate * 100));
		gtk_progress_bar_set_text(GTK_PROGRESS_BAR(widgets->progress), text);
		gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(widgets->progress), rate);
		UpdateWidget(widgets->progress);
		widgets->last_update = rate;
	}

	return widgets->cancel;
}

static void ChangeOverlap(GtkAdjustment* slider, PLUG_IN_WIDGETS* widgets)
{
	widgets->values->overlap = (int)gtk_adjustment_get_value(slider);
}

static void ChangeTileable(GtkWidget* button, PLUG_IN_WIDGETS* widgets)
{
	widgets->values->make_tileable = gtk_toggle_button_get_active(
		GTK_TOGGLE_BUTTON(button));
}

static void ChangeReverse(GtkWidget* button, PLUG_IN_WIDGETS* widgets)
{
	widgets->values->reverse = gtk_toggle_button_get_active(
		GTK_TOGGLE_BUTTON(button));
}

static void StopButtonClicked(PLUG_IN_WIDGETS* widgets)
{
	widgets->cancel = TRUE;
}

static void AddTexturizeHistory(DRAW_WINDOW* canvas, LAYER* new_layer, const char* plug_in_name)
{
	MEMORY_STREAM *stream = CreateMemoryStream(canvas->stride * canvas->height);
	guint32 data_size;

	data_size = (guint32)strlen(new_layer->name) + 1;
	(void)MemWrite(&data_size, sizeof(data_size), 1, stream);
	(void)MemWrite(new_layer->name, 1, data_size, stream);

	if(new_layer->prev != NULL)
	{
		data_size = (guint32)strlen(new_layer->prev->name) + 1;
		(void)MemWrite(&data_size, sizeof(data_size), 1, stream);
		(void)MemWrite(new_layer->prev->name, 1, data_size, stream);
	}
	else
	{
		data_size = 0;
		(void)MemWrite(&data_size, sizeof(data_size), 1, stream);
	}

	WritePNGStream((void*)stream, (stream_func_t)MemWrite, NULL,
		new_layer->pixels, new_layer->width, new_layer->height, new_layer->stride,
			new_layer->channel, 0, Z_DEFAULT_COMPRESSION
	);

	AddPlugInHistory(canvas, plug_in_name, stream->buff_ptr, stream->data_point);

	(void)DeleteMemoryStream(stream);
}

G_MODULE_EXPORT int Execute(APPLICATION* app, const char* plug_in_name, GModule* module)
{
#define DEFAULT_OVERLAP 100
#define MINIMUM_OVERLAP 25
	DRAW_WINDOW *canvas = GetActiveDrawWindow(app);
	PLUG_IN_VALUES values = {0};
	PLUG_IN_WIDGETS widgets = {0};
	GtkAdjustment *adjustment;
	GtkWidget *dialog;
	GtkWidget *vbox;
	GtkWidget *control;

	if(canvas == NULL)
	{
		return 0;
	}

	values.overlap = MINIMUM(DEFAULT_OVERLAP, canvas->width);

	dialog = gtk_dialog_new_with_buttons(
		"Texturize", GTK_WINDOW(app->window),
		GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
		GTK_STOCK_OK, GTK_RESPONSE_OK,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		NULL
	);

	vbox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(gtk_dialog_get_content_area(GTK_DIALOG(dialog))), vbox, FALSE, FALSE, 0);

	widgets.values = &values;
	adjustment = GTK_ADJUSTMENT(gtk_adjustment_new(values.overlap,
		MINIMUM(MINIMUM_OVERLAP, MINIMUM(canvas->width - 1, canvas->height - 1)),
		MINIMUM(canvas->width, canvas->height), 1, 5, 0));
	control = SpinScaleNew(adjustment, "Overlap (Pixels)", 0);
	(void)g_signal_connect(G_OBJECT(adjustment), "value_changed",
		G_CALLBACK(ChangeOverlap), &widgets);
	gtk_box_pack_start(GTK_BOX(vbox), control, FALSE, FALSE, 0);

	control = gtk_check_button_new_with_label("Tileable");
	(void)g_signal_connect(G_OBJECT(control), "toggled",
		G_CALLBACK(ChangeTileable), &widgets);
	gtk_box_pack_start(GTK_BOX(vbox), control, FALSE, FALSE, 0);

	control = gtk_check_button_new_with_label("Reverse");
	(void)g_signal_connect(G_OBJECT(control), "toggled",
		G_CALLBACK(ChangeReverse), &widgets);
	gtk_box_pack_start(GTK_BOX(vbox), control, FALSE, FALSE, 0);

	widgets.progress = gtk_progress_bar_new();
	gtk_box_pack_start(GTK_BOX(vbox), widgets.progress, FALSE, FALSE, 0);

	gtk_widget_show_all(dialog);

	if(gtk_dialog_run(GTK_DIALOG(dialog)) == GTK_RESPONSE_OK)
	{
		LAYER *new_layer;
		char layer_name[4096];
		int counter = 1;
		do
		{
			(void)sprintf(layer_name, "Texturize %d", counter);
			counter++;
		} while((new_layer = AddLayer(canvas, TYPE_NORMAL_LAYER, layer_name, canvas->active_layer)) == NULL);

		control = gtk_button_new_from_stock(GTK_STOCK_STOP);
		(void)g_signal_connect_swapped(G_OBJECT(control), "clicked",
			G_CALLBACK(StopButtonClicked), &widgets);
		gtk_box_pack_start(GTK_BOX(vbox), control, FALSE, FALSE, 0);
		gtk_widget_show(control);

		if(Render(canvas, new_layer, &values, (int (*)(float, void*))Progress, &widgets) == 0)
		{
			AddTexturizeHistory(canvas, new_layer, plug_in_name);
			UpdateDrawWindow(canvas);
		}
		else
		{
			RemoveLayer(new_layer);
		}
	}

	gtk_widget_destroy(dialog);

	return 0;
}

G_MODULE_EXPORT void Undo(DRAW_WINDOW* canvas, void* data, size_t data_length)
{
	MEMORY_STREAM stream = {(uint8*)data, 0, data_length, 1};
	LAYER *target;
	gchar *layer_name;
	guint32 data_size;

	(void)MemRead(&data_size, sizeof(data_size), 1, &stream);
	layer_name = (gchar*)g_malloc(data_size);
	(void)MemRead(layer_name, 1, data_size, &stream);

	target = SearchLayer(canvas->layer, layer_name);
	RemoveLayer(target);

	g_free(layer_name);
}

G_MODULE_EXPORT void Redo(DRAW_WINDOW* canvas, void* data, size_t data_length)
{
	MEMORY_STREAM stream = {(uint8*)data, 0, data_length, 1};
	LAYER *target;
	LAYER *prev = NULL;
	uint8 *pixels;
	gchar *layer_name;
	gchar *prev_name = NULL;
	guint32 data_size;
	gint32 width, height, stride;

	(void)MemRead(&data_size, sizeof(data_size), 1, &stream);
	layer_name = (gchar*)g_malloc(data_size);
	(void)MemRead(layer_name, 1, data_size, &stream);

	(void)MemRead(&data_size, sizeof(data_size), 1, &stream);
	if(data_size > 0)
	{
		prev_name = (gchar*)g_malloc(data_size);
		(void)MemRead(prev_name, 1, data_size, &stream);
		prev = SearchLayer(canvas->layer, prev_name);
	}

	target = AddLayer(canvas, TYPE_NORMAL_LAYER, layer_name, prev);
	pixels = ReadPNGStream(&stream, (stream_func_t)MemRead, &width, &height, &stride);

	(void)memcpy(target->pixels, pixels, target->width * target->height * target->channel);

	MemoryFree(pixels);
	g_free(prev_name);
	g_free(layer_name);

	UpdateDrawWindow(canvas);
}

#ifdef __cplusplus
}
#endif

#if defined(_MSC_VER)

#ifdef _UNICODE
# if defined _M_IX86
#  pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='x86' publicKeyToken='6595b64144ccf1df' language='*'\"")
# elif defined _M_IA64
#  pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='ia64' publicKeyToken='6595b64144ccf1df' language='*'\"")
# elif defined _M_X64
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='amd64' publicKeyToken='6595b64144ccf1df' language='*'\"")
# else
#  pragma comment(linker,"/manifestdependency:\"type='win32' 
name='Microsoft.Windows.Common-Controls' version='6.0.0.0' 
processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")
# endif
#endif

#pragma comment(lib, "MIKADO.lib")

#if defined(USE_3D_LAYER) && USE_3D_LAYER != 0
# pragma comment(lib, "OpenGL32.lib")
# pragma comment(lib, "GlU32.lib")
# ifdef TEST //_DEBUG
#  pragma comment(lib, "tbb_debug.lib")
#  pragma comment(lib, "tbb_preview_debug.lib")
#  pragma comment(lib, "tbbmalloc_debug.lib")
#  pragma comment(lib, "tbbproxy_debug.lib")
#  pragma comment(lib, "tbbmalloc_proxy_debug.lib")
#  pragma comment(lib, "BulletCollision_vs2008_debug.lib")
#  pragma comment(lib, "BulletDynamics_vs2008_debug.lib")
#  pragma comment(lib, "BulletSoftBody_vs2008_debug.lib")
#  pragma comment(lib, "ConvexDecomposition_vs2008_debug.lib")
#  pragma comment(lib, "LinearMath_vs2008_debug.lib")
#  pragma comment(lib, "OpenGLSupport_vs2008_debug.lib")
# else
#  pragma comment(lib, "tbb.lib")
#  pragma comment(lib, "tbb_preview.lib")
#  pragma comment(lib, "tbbmalloc.lib")
#  pragma comment(lib, "tbbproxy.lib")
#  pragma comment(lib, "tbbmalloc_proxy.lib")
#  pragma comment(lib, "BulletCollision_vs2008.lib")
#  pragma comment(lib, "BulletDynamics_vs2008.lib")
#  pragma comment(lib, "BulletSoftBody_vs2008.lib")
#  pragma comment(lib, "ConvexDecomposition_vs2008.lib")
#  pragma comment(lib, "LinearMath_vs2008.lib")
#  pragma comment(lib, "OpenGLSupport_vs2008.lib")
# endif
#endif

# ifndef BUILD64BIT
#  if defined(USE_STATIC_LIB) && USE_STATIC_LIB != 0
#   ifdef _DEBUG
#    pragma comment(linker, "/NODEFAULTLIB:LIBCMTD.lib")
#    pragma comment(lib, "gtk_libsd.lib")
#    pragma comment(lib, "Dnsapi.lib")
#    pragma comment(lib, "ws2_32.lib")
#    pragma comment(lib, "Shlwapi.lib")
#    pragma comment(lib, "imm32.lib")
#    pragma comment(lib, "zlib.lib")
#    pragma comment(lib, "libpng.lib")
#    pragma comment(lib, "usp10.lib")
cairo_surface_t *
cairo_image_surface_create_from_png (const char	*filename)
{
	return 0;
}
/*
#    pragma comment(linker, "/NODEFAULTLIB:LIBCMTD.lib")
#    pragma comment(lib, "Dnsapi.lib")
#    pragma comment(lib, "ws2_32.lib")
#    pragma comment(lib, "pcre3d.lib")
#    pragma comment(lib, "Shlwapi.lib")
#    pragma comment(lib, "atk-1.0.lib")
#    pragma comment(lib, "cairo.lib")
#    pragma comment(lib, "expat.lib")
#    pragma comment(lib, "fontconfig.lib")
#    pragma comment(lib, "freetype.lib")
#    pragma comment(lib, "gailutil.lib")
#    pragma comment(lib, "gdk_pixbuf-2.0.lib")
#    pragma comment(lib, "gdk-win32-2.0.lib")
#    pragma comment(lib, "./STATIC_LIB/giod.lib")
#    pragma comment(lib, "./STATIC_LIB/glibd.lib")
#    pragma comment(lib, "./STATIC_LIB/gmoduled.lib")
#    pragma comment(lib, "./STATIC_LIB/gobjectd.lib")
#    pragma comment(lib, "./STATIC_LIB/gthreadd.lib")
#    pragma comment(lib, "gtk-win32-2.0.lib")
#    pragma comment(lib, "intl.lib")
#    pragma comment(lib, "libpng.lib")
#    pragma comment(lib, "pango-1.0.lib")
#    pragma comment(lib, "pangocairo-1.0.lib")
#    pragma comment(lib, "pangoft2-1.0.lib")
#    pragma comment(lib, "pangowin32-1.0.lib")
#    pragma comment(lib, "zlib.lib")
*/
#   else
#    pragma comment(lib, "./STATIC_LIB/libatk-1.0.a")
#    pragma comment(lib, "./STATIC_LIB/libcairo.a")
#    pragma comment(lib, "./STATIC_LIB/libcairo-gobject.a")
#    pragma comment(lib, "./STATIC_LIB/libcairo-script-interpreter.a")
#    pragma comment(lib, "./STATIC_LIB/libcharset.a")
#    pragma comment(lib, "./STATIC_LIB/libexpat.a")
#    pragma comment(lib, "./STATIC_LIB/libffi.a")
#    pragma comment(lib, "./STATIC_LIB/libfontconfig.a")
#    pragma comment(lib, "./STATIC_LIB/libfreetype.a")
#    pragma comment(lib, "./STATIC_LIB/libgailutil.a")
#    pragma comment(lib, "./STATIC_LIB/libgdk_pixbuf-2.0.a")
#    pragma comment(lib, "./STATIC_LIB/libgdk-win32-2.0.a")
#    pragma comment(lib, "./STATIC_LIB/libgio-2.0.a")
#    pragma comment(lib, "./STATIC_LIB/libglib-2.0.a")
#    pragma comment(lib, "./STATIC_LIB/libgmodule-2.0.a")
#    pragma comment(lib, "gobject-2.0.lib")
#    pragma comment(lib, "gthread-2.0.lib")
#    pragma comment(lib, "gtk-win32-2.0.lib")
#    pragma comment(lib, "intl.lib")
#    pragma comment(lib, "libpng.lib")
#    pragma comment(lib, "pango-1.0.lib")
#    pragma comment(lib, "pangocairo-1.0.lib")
#    pragma comment(lib, "pangoft2-1.0.lib")
#    pragma comment(lib, "pangowin32-1.0.lib")
#    pragma comment(lib, "zlib.lib")
#   endif
#  else
#  ifdef _DEBUG
#   pragma comment(linker, "/NODEFAULTLIB:LIBCMT")
#  else
#   if _MSC_VER >= 1600
#    pragma comment(linker, "/NODEFAULTLIB:LIBCMT")
#   endif
#  endif
#   if GTK_MAJOR_VERSION <= 2
#    pragma comment(lib, "atk-1.0.lib")
#    pragma comment(lib, "cairo.lib")
#    pragma comment(lib, "expat.lib")
#    pragma comment(lib, "fontconfig.lib")
#    pragma comment(lib, "freetype.lib")
#    pragma comment(lib, "gailutil.lib")
#    pragma comment(lib, "gdk_pixbuf-2.0.lib")
#    pragma comment(lib, "gdk-win32-2.0.lib")
#    pragma comment(lib, "gio-2.0.lib")
#    pragma comment(lib, "glib-2.0.lib")
#    pragma comment(lib, "gmodule-2.0.lib")
#    pragma comment(lib, "gobject-2.0.lib")
#    pragma comment(lib, "gthread-2.0.lib")
#    pragma comment(lib, "gtk-win32-2.0.lib")
#    pragma comment(lib, "intl.lib")
#    pragma comment(lib, "libpng.lib")
#    pragma comment(lib, "pango-1.0.lib")
#    pragma comment(lib, "pangocairo-1.0.lib")
#    pragma comment(lib, "pangoft2-1.0.lib")
#    pragma comment(lib, "pangowin32-1.0.lib")
#    if defined(_M_X64) || defined(_M_IA64)
#     pragma comment(lib, "zdll.lib")
#    else
#     pragma comment(lib, "zlib.lib")
#    endif
#   else
#    ifdef _DEBUG
//#     pragma comment(linker, "/NODEFAULTLIB:MSVCRTD")
#    else
#     pragma comment(linker, "/NODEFAULTLIB:MSVCRT")
#    endif

#    if defined(_M_X64) || defined(_M_IA64)
#     pragma comment(lib, "libpng.lib")
#    else
#     pragma comment(lib, "libpng.lib")
#    endif
#    pragma comment(lib, "zlib.lib")
#    pragma comment(lib, "cairo.lib")
#    pragma comment(lib, "atk-1.0.lib")
#    pragma comment(lib, "fontconfig.lib")
#    pragma comment(lib, "gailutil.lib")
#    pragma comment(lib, "gdk_pixbuf-2.0.lib")
#    pragma comment(lib, "gdk-win32-3.0.lib")
#    pragma comment(lib, "gio-2.0.lib")
#    pragma comment(lib, "glib-2.0.lib")
#    pragma comment(lib, "gmodule-2.0.lib")
#    pragma comment(lib, "gobject-2.0.lib")
#    pragma comment(lib, "gthread-2.0.lib")
#    pragma comment(lib, "gtk-win32-3.0.lib")
#    pragma comment(lib, "pango-1.0.lib")
#    pragma comment(lib, "pangocairo-1.0.lib")
#    pragma comment(lib, "pangoft2-1.0.lib")
#    pragma comment(lib, "pangowin32-1.0.lib")
#    pragma comment(lib, "libgettextsrc-0-18-2.lib")
#    pragma comment(lib, "libgettextpo-0.lib")
#    pragma comment(lib, "libgettextlib-0-18-2.lib")
#    pragma comment(lib, "libintl-8.lib")

#    pragma comment(lib, "libatk-1.0-0.lib")
#    pragma comment(lib, "libcairo-2.lib")
#    pragma comment(lib, "libcairo-gobject-2.lib")
#    pragma comment(lib, "libcairo-script-interpreter-2.lib")
#    pragma comment(lib, "libcroco-0.6-3.lib")
#    pragma comment(lib, "libffi-6.lib")
#    pragma comment(lib, "libfontconfig-1.lib")
#    pragma comment(lib, "libfreetype-6.lib")
#    pragma comment(lib, "libgailutil-3-0.lib")
#    pragma comment(lib, "libgdk_pixbuf-2.0-0.lib")
#    pragma comment(lib, "libgdk-3-0.lib")
#    pragma comment(lib, "libgio-2.0-0.lib")
#    pragma comment(lib, "libglib-2.0-0.lib")
#    pragma comment(lib, "libgmodule-2.0-0.lib")
#    pragma comment(lib, "libgthread-2.0-0.lib")
#    pragma comment(lib, "libgtk-3-0.lib")
#    pragma comment(lib, "libjasper-1.lib")
#    pragma comment(lib, "libjpeg-9.lib")
#    pragma comment(lib, "liblzma-5.lib")
#    pragma comment(lib, "libpango-1.0-0.lib")
#    pragma comment(lib, "libpangocairo-1.0-0.lib")
#    pragma comment(lib, "libpangoft2-1.0-0.lib")
#    pragma comment(lib, "libpangowin32-1.0-0.lib")
#    pragma comment(lib, "libpixman-1-0.lib")
#    pragma comment(lib, "librsvg-2-2.lib")
#    pragma comment(lib, "libtiff-5.lib")
#    pragma comment(lib, "libxml2-2.lib")
#    pragma comment(lib, "zdll.lib")

#   endif
#  endif
# else
#  ifdef _DEBUG
#   pragma comment(linker, "/NODEFAULTLIB:LIBCMTD")
#  else
//#   pragma comment(linker, "/NODEFAULTLIB:LIBCMT")
#  endif
#  if GTK_MAJOR_VERSION <= 2
#   pragma comment(lib, "atk-1.0.lib")
#   pragma comment(lib, "cairo.lib")
#   pragma comment(lib, "expat.lib")
#   pragma comment(lib, "fontconfig.lib")
#   pragma comment(lib, "freetype.lib")
#   pragma comment(lib, "gailutil.lib")
#   pragma comment(lib, "gdk_pixbuf-2.0.lib")
#   pragma comment(lib, "gdk-win32-2.0.lib")
#   pragma comment(lib, "gio-2.0.lib")
#   pragma comment(lib, "glib-2.0.lib")
#   pragma comment(lib, "gmodule-2.0.lib")
#   pragma comment(lib, "gobject-2.0.lib")
#   pragma comment(lib, "gthread-2.0.lib")
#   pragma comment(lib, "gtk-win32-2.0.lib")
#   pragma comment(lib, "intl.lib")
#   pragma comment(lib, "libpng.lib")
#   pragma comment(lib, "pango-1.0.lib")
#   pragma comment(lib, "pangocairo-1.0.lib")
#   pragma comment(lib, "pangoft2-1.0.lib")
#   pragma comment(lib, "pangowin32-1.0.lib")
#   if defined(_M_X64) || defined(_M_IA64)
#    pragma comment(lib, "zdll.lib")
#   else
#    pragma comment(lib, "zlib.lib")
#   endif
#  else
#    pragma comment(lib, "libpng15-15.lib")
#    pragma comment(lib, "zlib.lib")
#    pragma comment(lib, "libz.dll.a")
#    pragma comment(lib, "cairo.lib")
#    pragma comment(lib, "atk-1.0.lib")
#    pragma comment(lib, "fontconfig.lib")
#    pragma comment(lib, "gailutil.lib")
#    pragma comment(lib, "gdk_pixbuf-2.0.lib")
#    pragma comment(lib, "gdk-win32-3.0.lib")
#    pragma comment(lib, "gio-2.0.lib")
#    pragma comment(lib, "glib-2.0.lib")
#    pragma comment(lib, "gmodule-2.0.lib")
#    pragma comment(lib, "gobject-2.0.lib")
#    pragma comment(lib, "gthread-2.0.lib")
#    pragma comment(lib, "gtk-win32-3.0.lib")
#    pragma comment(lib, "pango-1.0.lib")
#    pragma comment(lib, "pangocairo-1.0.lib")
#    pragma comment(lib, "pangoft2-1.0.lib")
#    pragma comment(lib, "pangowin32-1.0.lib")
#    pragma comment(lib, "intl.lib")

#    pragma comment(lib, "libatk-1.0-0.lib")
#    pragma comment(lib, "libcairo.dll.a")
#    pragma comment(lib, "libcairo-gobject.dll.a")
#    pragma comment(lib, "libcairo-script-interpreter.dll.a")
#    pragma comment(lib, "libcroco-0.6.dll.a")
#    pragma comment(lib, "libffi.dll.a")
#    pragma comment(lib, "libfontconfig.dll.a")
#    pragma comment(lib, "libfreetype.dll.a")
#    pragma comment(lib, "libgailutil-3.dll.a")
#    pragma comment(lib, "libgdk_pixbuf-2.0.dll.a")
#    pragma comment(lib, "libgdk-3.dll.a")
#    pragma comment(lib, "libgio-2.0.dll.a")
#    pragma comment(lib, "libglib-2.0.dll.a")
#    pragma comment(lib, "libgmodule-2.0.dll.a")
#    pragma comment(lib, "libgthread-2.0.dll.a")
#    pragma comment(lib, "libgtk-3.dll.a")
#    pragma comment(lib, "libjasper.dll.a")
#    pragma comment(lib, "libjpeg.dll.a")
#    pragma comment(lib, "liblzma.dll.a")
#    pragma comment(lib, "libpango-1.0.dll.a")
#    pragma comment(lib, "libpangocairo-1.0.dll.a")
#    pragma comment(lib, "libpangoft2-1.0.dll.a")
#    pragma comment(lib, "libpangowin32-1.0.dll.a")
#    pragma comment(lib, "libpixman-1.dll.a")
#    pragma comment(lib, "librsvg-2.dll.a")
#    pragma comment(lib, "libtiff.dll.a")
#    pragma comment(lib, "libtiffxx.dll.a")
#    pragma comment(lib, "libxml2.dll.a")
#  endif
# endif
#endif
